#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_main.py                                                        
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_main.py 
________________________________________________________________________
'''
import cgi, cgitb
cgitb.enable()

import sys, os
import codecs
import time, datetime

from a_konstanten import *

import a_tool
import a_db
import a_session as a_s
import a_js, a_h
import a_datum


##########################################
# A B S E N Z eintragen bzw. aktualisieren
def setze_absenz(pid,datum):
    
    if a_s.aS.aktion==0: 
        return "-Bitte erst eine Aktion auswählen" if a_s.aS.maxaktion>0 else "-Bitte erst anmelden"
    if not (a_s.aS.zeige_reales_schuljahr and a_s.aS.zeige_konfiguriertes_schuljahr):
        return "-Nur im aktuellen Schuljahr mit in diesem Schuljahr eingelesenen Listen können Absenzen eingetragen werden"
        
    aktjs=a_s.aS.get_aktjs()
    teilflag=1 if (a_s.aS.aktion==LEVEL_ENTSCHULDIGUNG and a_s.aS.get_halbtagsflag()) else 0
    verb=STATUSSTRG[a_s.aS.aktion]
    if teilflag:
        pos=verb.find("&")
        verb=verb[:pos]+'&nbsp;stundenw.'+verb[pos:]
    if (a_s.aS.aktion==LEVEL_VERMISST or a_s.aS.aktion==LEVEL_SCHULBEFREIUNG) and aktjs>=21 and not a_s.aS.kurs in alphabetisch:
        verb+=' in '+a_s.aS.kurs
    
    
    neuerkommentar=a_datum.isodatum2datum(a_datum.timestamp2isodatum(a_datum.get_timestamp()))+" "+verb+" ("+a_s.aS.klarname+")"
    if a_s.aS.aktion==LEVEL_SCHULBEFREIUNG:
        befreiungstext=a_db.get_first_element('SELECT befreiungstext FROM sessions WHERE sid=?',(a_s.aS.sid,),"") 
        if befreiungstext:
            neuerkommentar+='<br> "'+befreiungstext+'"'
    name=""
    kommentar=''
    row=a_db.get_one_rowdict('''SELECT pid,name,apdatum,js FROM personen WHERE pid=?''',(pid,))
    if row:
        pid,name,apdatum,js = row
    else:
        return '-PID konnte nicht zugeordnet werden - interner Fehler'
    a_s.aS.setze_highlight(pid)
    
    if js<20:   mindatum=a_db.get_config('intern_mindestdatum-gum')
    if js>20:   mindatum=a_db.get_config('intern_mindestdatum-kj_'+str(js-20))
    if datum<mindatum:
        return '-Dieser Zeitraum ist fixiert. Erst ab dem '+a_datum.isodatum2datum(mindatum)+' dürfen Absenzen eingegeben/geändert werden'
        
    # Zuerst die Sonderaktion außer der aufsteigenden, mit dem Status assoziierten Reihe
    
    ## Umschalten zwischen ganztags/halbtags
    flag=a_s.aS.ist_es_mit_genug_rechten(AKTION_TOGGLE_TEILFLAG)
    if flag==1:
        zeile=a_db.get_one_rowdict('''
            SELECT status,attestpflicht, kommentar,teilflag FROM absenzen WHERE pid=? AND datum=? ''',(pid,datum))
        if zeile:
            status,attestplicht,kommentar,teilflag=zeile
            if status>=LEVEL_ENTSCHULDIGUNG: #wenn es diese Absenz mit dem status gibt, dann wird flag umgedreht            
                neuflag=1 if teilflag==0 else 0
                flagtext='ganztags' if not neuflag else 'stundenweise'
                neuerkommentar=kommentar+'<br>'+neuerkommentar+' auf '+flagtext
                a_s.sichere_absenz(pid,datum,neuerkommentar)
                a_db.execute('''
                    UPDATE absenzen
                    SET teilflag=?, kommentar=? 
                    WHERE pid=? AND datum=? ''',(neuflag,neuerkommentar,pid,datum))
                meldung='Ändere Absenz von '+name+' für '+a_datum.isodatum2datum(datum)+' auf "'+flagtext+'"'
                return '+'+meldung
            return '-Erst mit einer Entschuldigung kann diese Entscheidung getroffen werden'
        return '-Hier gibt es noch keine Absenz'
    if flag==-1:
        return '-Dazu fehlen Ihnen die Rechte'
        
    ## Allgemeine Attestpflicht verhängen
    flag=a_s.aS.ist_es_mit_genug_rechten(AKTION_ALLGEMEINE_ATTESTPFLICHT)
    if flag==1:
        if apdatum==datum:
            datum='9999-99-99'
            meldung='+Attestpflicht für '+name+' aufgehoben'
        elif apdatum=='9999-99-99':
            meldung='+Attestpflicht für '+name+' ab '+a_datum.isodatum2datum(datum)+' festgelegt'
        else:
            return '-Attestpflicht muss erst gelöscht werden, bevor sie neu gesetzt werden kann! Dazu auf das alte Datum klicken!'
        a_s.remove_undo()
        a_db.execute('''
            UPDATE personen
            SET apdatum=?
            WHERE pid=?''',(datum,pid))
        return meldung
    if flag==-1:
        return '-Zum Setzen einer allg. Attestpflicht sind Sie in diesem Kurs/Klasse nicht berechtigt'
        

    status=-1
    attestplicht=0
    zeile=a_db.get_one_rowdict('''
        SELECT status,attestpflicht, kommentar FROM absenzen WHERE pid=? AND datum=? ''',(pid,datum))
    if zeile:
        status,attestplicht,kommentar=zeile

    ## Neue Absenz anlegen
    if status==-1 and a_s.aS.aktion<=LEVEL_ATTESTOK: #diese Absenz gibt es noch nicht, darf aber angelegt werden
        if a_s.aS.genug_rechte():
            ap=0
            if a_s.aS.aktion>=LEVEL_VERMISST and a_db.get_config_int('flag_auto_absenz')>0:
                if teste_vortagsabsenzen(pid,datum):
                    neuerkommentar+='<br>Automatische Attestpflicht wg. drei Tagen in Folge'
                    ap=1
            a_s.sichere_absenz(pid,datum,neuerkommentar) # sichert nur die info, was rückgängig zu machen ist
            a_db.execute('''
            INSERT INTO absenzen (pid, status, attestpflicht, datum, kommentar, teilflag) 
                VALUES (?,?,?,?,?,?) ''',(pid,a_s.aS.aktion,ap,datum,neuerkommentar,teilflag))
            meldung='+Neue Absenz von '+name+' für '+a_datum.isodatum2datum(datum)+' mit Status "'+verb+'"'
            if a_s.aS.aktion==LEVEL_SCHULBEFREIUNG and befreiungstext:
                meldung+=' mit Begründung "'+befreiungstext+'"'
        else:
            meldung='-Dazu fehlen Ihnen in diesem Kurs/Klasse die Rechte'
        return meldung

    neuerkommentar=kommentar+'<br>'+neuerkommentar
        
    ## Löschen einer bestehenden Absenz
    flag=a_s.aS.ist_es_mit_genug_rechten(AKTION_LOESCHEN)
    if flag==1:
        if status>LEVEL_GELOESCHT:
            a_s.sichere_absenz(pid,datum,neuerkommentar)
            a_db.execute('''
                UPDATE absenzen
                SET status=?, attestpflicht=0, kommentar=?, teilflag=0 
                WHERE pid=? AND datum=? ''',(LEVEL_GELOESCHT,neuerkommentar,pid,datum))
            meldung='+Lösche Absenz von '+name+' für '+a_datum.isodatum2datum(datum)+' in "'+verb+'"'
            return meldung
        return '-Hier gab es nichts zu löschen'
    if flag==-1:
        return '-Ihnen fehlen die Rechte, um in diesem Kurs/Klasse etwas zu löschen!'

    if status==LEVEL_SCHULBEFREIUNG:
        return '-Eine Schulbefreiung kann nur gelöscht werden'
        
    ## Ändern einer Absenz
    if a_s.aS.aktion<=LEVEL_ATTESTOK: # Normale Absenzänderung
        if a_s.aS.genug_rechte():
            if a_s.aS.aktion>status or status==LEVEL_VERMISST: # Vermisst darf mehrfach eingegeben werden
                a_s.sichere_absenz(pid,datum,neuerkommentar)
                if teilflag:
                    a_db.execute('''
                        UPDATE absenzen
                        SET status=?, kommentar=?, teilflag=1 
                        WHERE pid=? AND datum=? ''',(a_s.aS.aktion,neuerkommentar,pid,datum))
                else:
                    a_db.execute('''
                        UPDATE absenzen
                        SET status=?, kommentar=? 
                        WHERE pid=? AND datum=? ''',(a_s.aS.aktion,neuerkommentar,pid,datum))
                    
                meldung='Ändere Absenz von '+name+' für '+a_datum.isodatum2datum(datum)+' in "'+verb+'"'
                return '+'+meldung
            else: return '-Der Status von '+name+' kann nicht erneut gesetzt - oder herabgesetzt - werden'
        return '-Ihnen fehlen hierzu die Rechte'
    
    # bleibt nur noch das Setzen einer Attestpflicht für den Tag
    if attestplicht!=0:
        return '-Attestplicht war bereits gesetzt'
    if status<LEVEL_VERMISST:
        return '-Hier gibt es keine Absenz für eine Attestpflicht'
    
    flag=a_s.aS.ist_es_mit_genug_rechten(AKTION_ATTESTPFLICHT)
    if flag==1:
        a_s.sichere_absenz(pid,datum,neuerkommentar)
        a_db.execute('''
            UPDATE absenzen
            SET attestpflicht=1, kommentar=? 
            WHERE pid=? AND datum=? ''',(neuerkommentar,pid,datum))
        meldung='Absenz von '+name+' für '+a_datum.isodatum2datum(datum)+' erhielt individuelle Attestplicht'
        return '+'+meldung
    if flag==-1:
        return '-In diesem Kurs/Klasse fehlen Ihnen die Rechte für das Setzen einer Attestpflicht'
    return '-Unerwartetes Ergebnis'
    
    
def teste_vortagsabsenzen(pid,datum):
    t,m,j=a_datum.isodatum2int(datum)
    d_vor=a_datum.timestamp2isodatum(a_datum.ts_erstellen(j,m,t-1))
    d_vorvor=a_datum.timestamp2isodatum(a_datum.ts_erstellen(j,m,t-2))
    row=a_db.get_one_rowdict('''
        SELECT count(datum) FROM absenzen WHERE pid=? AND status>=? AND (datum=? OR datum=?)''',(pid,LEVEL_VERMISST,d_vor,d_vorvor))
    if row: 
        if row[0]>1: return True
    return False
    
def erledige_aktionen_auswahl():
    undomoeglich=a_db.get_existenz('SELECT pid FROM absenzenundo WHERE sid=?',(a_s.aS.sid,))
    if undomoeglich:
        undobutton='''<li><a href="a_main.py?undonow=true" title=
"Die letzte Änderung einer Absenz\n(für einen Tag und einen Schüler)
kann hier rückgängig gemacht werden."><span style="color:yellow">↶</span> Rückgängig</a></li>\n'''
### Formatierung wegen der Darstellung im "title"
    else:
        undobutton='''<li><a title=
"Derzeit gibt es nichts rückgängig zu machen!\nNur die letzte Änderung einer Absenz
(für einen Tag und einen Schüler)\nkönnte hier rückgängig gemacht werden.">
            <span style="color:lightgrey">↶ Rückgängig</span></a></li>\n'''

    a_tool.prt('\n<div class="gradientbuttons">')
    a_tool.prt('<ul>') 
    legaleaktion=False
    buttons_bis_break=3
    for i in range(1,11):
        if  a_s.aS.genug_rechte(i):
            if not buttons_bis_break: 
                a_tool.prt('<br>'); buttons_bis_break=3
            if i==a_s.aS.aktion:
                extrastyle='style="color:#117"' 
                legaleaktion=True
            else:
                extrastyle='' 
            if i!=4:
                a_tool.prt('<li><a href="a_main.py?aktion='+str(i)+'" '+extrastyle+' title="'+atitlestrg[i]+'">'+STATUSDECO[i]+STATUSSTRG[i]+'</a></li>\n')
            else:
                if a_s.aS.get_halbtagsflag():
                    g_extra=''; h_extra=extrastyle
                else:
                    h_extra=''; g_extra=extrastyle
                a_tool.prt('<li><a class="left" href="a_main.py?aktion='+str(i)+'" '+g_extra+' title="ganztägige '+atitlestrg[i]+'">'+STATUSDECO[i]+STATUSSTRG[i]+'</a></li>\n')
                a_tool.prt('<li><a class="right" href="a_main.py?aktion='+str(i)+'&halbtagsflag=1" '+h_extra+' title="stundenweise '+atitlestrg[i]+'">'+STATUSDECO[i]+"½"+STATUSSTRG[i]+'</a></li>\n')
                buttons_bis_break-=1
            buttons_bis_break-=1
    
    if not buttons_bis_break: 
        a_tool.prt('<br>'); buttons_bis_break=3
    a_tool.prt(undobutton)
    buttons_bis_break-=1
    
    if a_s.aS.aktion==LEVEL_SCHULBEFREIUNG:
        if not buttons_bis_break: 
            a_tool.prt('<br>'); buttons_bis_break=3
        a_tool.prt('<li><a href="a_session.py?edit=befreiungstext" style="color:#FE9;" target="_blank" title="SchulBefreiungsEditor\nHier können Sie einstellen, weswegen eine Schulbefreiung erteilt wird." onclick="return popup(this.href);">SBE</a></li>\n')
        buttons_bis_break-=1
    a_tool.prt('</ul>')
    if not legaleaktion:
        a_s.aS.setze_aktion(0)
        a_tool.prt('<br> <span style="color:red;"> &nbsp; Wählen Sie eine zulässige Aktion!</span>')
    a_tool.prt('</div>\n')
    
def erledige_useraenderungen():
    ua_erfolg=""
    if not a_s.aS.kuerzel=='Gast':
        uasid=a_tool.getcgiparameter('uasid',"")
        if uasid==str(a_s.aS.sid):  #so sind wir nicht durch einen schlichten Link angreifbar
            neuespasswort1=a_tool.getcgiparameter('neuespasswort1',"")
            neuespasswort2=a_tool.getcgiparameter('neuespasswort2',"")
            neueskuerzel=a_tool.getcgiparameter('neueskuerzel',"")
            if neuespasswort1==neuespasswort2 and len(neuespasswort1)>=4:
                if len(neueskuerzel)<2: neueskuerzel=a_s.aS.kuerzel
                ua_erfolg+=a_tool.setze_user_passwort(a_s.aS.user_nr,neueskuerzel,neuespasswort1)
                if ua_erfolg[0]=='+':
                    a_s.aS.setze_kuerzel(neueskuerzel)
            else:
                return "- Passwörter unterschiedlich" if not (neuespasswort1==neuespasswort2 ) else "- Passwort zu kurz"
        else:
            if len(uasid)>1: ua_erfolg+="- Aufruf mit falscher SessionID"
    return ua_erfolg
    
def erledige_userdialog():
    ua_erfolg=""
    k_value='value="'+cookiekuerzel+'"' if cookiekuerzel else ''
    ## Ein Gast bekommt den Anmeldedialog
    if a_s.aS.kuerzel=='Gast':
        nameselect=a_tool.get_nameselect()
        a_tool.prt('''<form action="a_main.py" method="post"><small>
            Name:'''+nameselect+'''
            oder Kürzel: <input name="loginkuerzel" size="5" maxlength="8" ''' + k_value +
            ''' >
            Passwort: <input name="loginpwd" size="5" maxlength="20" type="password" ></small>
            <input value="Anmelden" type="submit">
            <input name="loginsid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
    ## Sonst werden neue Eingaben ermöglicht
    else:
        ### Eine Tabelle, um links "Abmelden" zu können und rechts Verschiedenes anzeigen zu können
        a_tool.prt('<table style="width:100%;border:0; background:lightgrey"><tr><td style="border:0; background:lightgrey; vertical-align:top; text-align:center;">')
        ### Links den Abmeldebutton
        a_tool.prt('''<form action="a_main.py" method="post">
            <input name="loginkuerzel" value="Gast" type="hidden">
            <input value="Abmelden" type="submit">
            <input name="loginsid" value="4711" type="hidden"></form>''')
        a_tool.prt('</td></tr><tr>')
        ### Rechts...
        if not a_s.aS.kuerzel=='admin':
            ua_todo=a_tool.getcgiparameter('ua_todo',"")
            if len(a_s.aS.kuerzel)>6:
                ### bei frischen Accounts in gelb eine Passwortänderung anmahnen
                a_tool.prt('<td  style="border:0; border-left:1px; background:yellow; text-align:right;">')
            elif ua_todo in ['passwort','kuerzel']:
                ### sonst bläulichen Dialog bei Eingaben
                a_tool.prt('<td  style="border:0; border-left:1px; background:lightblue; text-align:right;">')
            else:
                ### oder das Einheitsgrau
                a_tool.prt('<td  style="border:0; border-left:1px; background:lightgrey;  text-align:center;">')
            ### Passwortänderung
            if len(a_s.aS.kuerzel)>6:
                a_tool.prt('<b>Ihr Passwort muss nun geändert werden!</b>')
            if ua_todo=='passwort' or len(a_s.aS.kuerzel)>6 or ua_todo=='kuerzel':
                a_tool.prt('''<form action="a_main.py" method="post"><small>
                    Neues Passwort: <input name="neuespasswort1" size="5" maxlength="20" type="password" ><br>
                    wiederholen: <input name="neuespasswort2" size="5" maxlength="20" type="password" ><br>''')
                if len(a_s.aS.kuerzel)<=6 and not ua_todo=='kuerzel' :
                    a_tool.prt('''<input value="Ändern" type="submit">
                        <input name="uasid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>''')
                
            ### Kürzeländerung
            if ua_todo=='kuerzel' or len(a_s.aS.kuerzel)>6:
                a_tool.prt('<br></small>Setzen Sie hier Ihr<br><b>offizielles Kürzel</b> ein<small><br>')
                kuerzelnennung=a_s.aS.kuerzel if len(a_s.aS.kuerzel)<=6 else ""
                a_tool.prt('''Kürzel: <input name="neueskuerzel" size="5" maxlength="5" value="'''+kuerzelnennung+'''"></small><br>
                    <input value="Ändern" type="submit">
                    <input name="uasid" value="'''+str(a_s.aS.sid)+'" type="hidden"><br>Bei Kürzeländerung <b>muss</b> auch<br>das Passwort erneut<br>eingegeben werden!</form>''')
            
            ### Buttons, um selber eine der beiden Änderungen anzufordern
            if ua_todo!='kuerzel' and ua_todo!='passwort' and len(a_s.aS.kuerzel)<=6:
                
                a_tool.prt('''<form action="a_main.py" method="post">
                       <input name="ua_todo" value="passwort" type="hidden">
                       <input value="Passwort ändern" type="submit"></form>''')
                a_tool.prt('''<form action="a_main.py" method="post">
                       <input name="ua_todo" value="kuerzel" type="hidden">
                       <input value="Kürzel ändern" type="submit"></form>''')
        else:
            a_tool.prt('<td  style="border:0; border-left:1px; background:lightgrey; text-align:right">')
        a_tool.prt('</td></tr></table>')
    return ua_erfolg
    


def ist_legitimer_admin(testsid):
    if a_s.aS.kuerzel=='admin' and str(a_s.aS.sid)==testsid:
        return True
    return False

def popupverwaltung(popupaktion):
    ## Soll ein Popupfenster als csv- oder html-Datei gefüllt werden? Ohne Dekoration/Menüs anzeigen und beenden!
    if popupaktion=="schuelercodes" and a_s.aS.kuerzel=="admin":
        import a_verwalter
        a_tool.print_file_start(body=a_verwalter.stammdatenanzeige_schueler(schuelercodes=True), \
                                   filetype='csv', filename='codes.csv')
        sys.exit()
    if popupaktion=="lehrercodes" and a_s.aS.kuerzel=="admin":
        a_tool.prt('Content-Type: text/csv; charset=utf-8\n')
        a_tool.prt('Content-Disposition: attachment;filename=passwds.csv\n\n')
        import a_verwalter
        a_tool.prt(a_verwalter.stammdatenanzeige_lehrer(lehrercodes=True))
        sys.exit()
    if popupaktion=="lehrerbrief" and a_s.aS.kuerzel=="admin":
        a_tool.prt('Content-Type: text/html; charset=utf-8\n')
        a_tool.prt('Content-Disposition: attachment;filename=lehrerbrief.html\n\n')
        import a_verwalter
        a_tool.prt(a_verwalter.stammdatenanzeige_lehrer(lehrerbrief=True))
        sys.exit()
    if popupaktion=="schuelerbrief" and a_s.aS.kuerzel=="admin":
        a_tool.prt('Content-Type: text/html; charset=utf-8\n')
        a_tool.prt('Content-Disposition: attachment;filename=schuelerbrief.html\n\n')
        import a_verwalter
        a_tool.prt(a_verwalter.stammdatenanzeige_schueler(schuelerbrief=True))
        sys.exit()
        
    if popupaktion=="absenzenbrief" and (a_s.aS.ist_ein_verwalter() or a_s.aS.genug_rechte(RECHTE_ABSENZENBLATT)):
        
        datumsstart=a_s.schuljahresgrenze_iso()
        datumslimit=a_tool.getcgiparameter('datumslimit','9999-99-99')
        einzelschueler=a_tool.getcgiparameter('einzelschueler','')
        import a_verwalter
        if not einzelschueler.isdigit():
            a_tool.prt('Content-Type: text/html; charset=utf-8\n')
            a_tool.prt('Content-Disposition: attachment;filename=absenzenbrief.html\n\n')
            a_tool.prt(a_verwalter.gesamtansicht(absenzenbrief=True,datumsstart=datumsstart,datumslimit=datumslimit))
            sys.exit()
        else:
            einzelschueler=int(einzelschueler)
            a_tool.prt('Content-Type: text/html\n\n')
            a_tool.prt(a_verwalter.gesamtansicht(absenzenbrief=True,datumsstart=datumsstart,datumslimit='9999-99-99',einzelschueler=int(einzelschueler)))
            sys.exit()

    if popupaktion=="importlog" and a_s.aS.kuerzel=='admin':
        a_h.merke_body('<pre>importlog-START\n')
        with codecs.open(a_tool.get_datenpfad()+"import.log",mode="r",encoding='utf-8') as f:
            for zeile in f:
                a_h.merke_body(zeile) # da \n enthalten
        a_tool.print_file_start(body='\nimportlog-ENDE</pre>\n</body></html>', filetype='html', filename='import.log.html')
        sys.exit()
        
    ## HTTP-Header und HTML-Head
    
    a_h.merke_header_zeile('<meta http-equiv="refresh" content="{timeout}; URL=a_main.py" />'.format(timeout=a_s.aS.get_loginzeit()+10))
    
    ## Popupfenster als HTML-Datei? Ohne Dekoration/Menüs anzeigen und beenden!
    if popupaktion=="gesamtansicht" and a_s.aS.ist_ein_verwalter():
        import a_verwalter
        a_tool.print_file_start(body=a_verwalter.gesamtansicht(mitauswahl=False)+'</body></html>')
        sys.exit()

    if popupaktion=="tagesliste" and a_s.aS.ist_seki_in(0):
        tageslistendatum=a_tool.getcgiparameter('tageslistendatum','')
        import a_verwalter
        a_tool.print_file_start(body=a_verwalter.get_tagesliste(tageslistendatum))
        sys.exit()
    
    if popupaktion=="mailtest" and a_s.aS.ist_ein_verwalter():
        import mail2ab
        a_tool.print_file_start(body=mail2ab.testmailsenden())
        sys.exit()
            
    if popupaktion=="poptest" and a_s.aS.ist_ein_verwalter():
        import mail2ab
        a_tool.print_file_start(mail2ab.testmailholen())
        sys.exit()
    
    if popupaktion=="kursliste_leer":
        import a_tabelle
        a_tool.print_file_start(body=a_tabelle.export_absenzentabelle(leere_liste=True))
        sys.exit()
    
    if popupaktion=="kursliste_absenzen":
        import a_tabelle
        a_tool.print_file_start(body=a_tabelle.export_absenzentabelle(leere_liste=False))
        sys.exit()
    
    if popupaktion=="schueler_kalender":
        import a_tabelle
        a_tool.print_file_start(body=a_tabelle.schueler_kalender())
        sys.exit()
    # wenn wir hier ankommen war eine falsche popupaktion gesetzt - egal, zurück
    
def setze_gespraech(pid,datum):
    klarname=a_db.get_first_element('''SELECT klarname FROM gespraeche WHERE pid=? AND datum=?''',(pid,datum),'')
    if klarname:
        if klarname==a_s.aS.klarname:
            a_db.execute('''DELETE FROM gespraeche WHERE pid=? AND datum=?''',(pid,datum))
            return '+Gesprächsnotiz wurde gelöscht.'
        else:
            return '-Gesprächsnotiz war nicht von Ihnen.'
    a_db.execute('''INSERT INTO gespraeche (pid,datum,klarname,kommentar) VALUES (?,?,?,?)''',(pid,datum,a_s.aS.klarname,""))
    return '+Gesprächsnotiz wurde angelegt für '+datum
    
#######################################################
#######################################################
# Alles startet hier...
#######################################################
#######################################################
def absentmain(erfolgsmeldung="", kurspflicht="", fehlerliste=""):
    global cookiekuerzel
    loginkuerzel=a_tool.getcgiparameter('loginkuerzel',"")
    loginklarname=a_tool.getcgiparameter('loginklarname',"")
    loginpwd=a_tool.getcgiparameter('loginpwd',"")
    loginsid=a_tool.getcgiparameter('loginsid',"")
    ## Session & Login klären
    erfolgsmeldung+=initmeldung
    em,ck=a_s.check_session(loginklarname,loginkuerzel,loginpwd,loginsid) # gibt evtl. ein Cookie aus - deshalb noch vor dem HTTP-Header!
    erfolgsmeldung+=em
    if ck:
        cookiekuerzel=ck
                
    popupaktion=a_tool.getcgiparameter('popupaktion',"")
    if popupaktion:
        popupverwaltung(popupaktion)
        # kommt bei Erfolg nicht mehr zurück
    else: 
        a_h.merke_header_zeile('<meta http-equiv="refresh" content="{timeout}; URL=a_main.py" />'.format(timeout=a_s.aS.get_loginzeit()+10)) # wurde auch in popupverwaltung gesetzt
    
    ########
    # Nun der Einlesen der Werte 
    ########
    
    aktion=a_tool.getcgiparameter('aktion',"")
    if aktion.isdigit():
        erfolgsmeldung+=a_s.aS.setze_aktion(int(aktion))
        if int(aktion)==LEVEL_ENTSCHULDIGUNG:
            if int(a_tool.getcgiparameter('halbtagsflag',"0"))>0:
                a_s.aS.setze_halbtagsflag(1)
            else:
                a_s.aS.setze_halbtagsflag(0)
        
    kurs=a_tool.getcgiparameter('kurs',kurspflicht)  # ggf. übergebener Wert kurspflicht wird als Defaultwert gesetzt und auch realisiert, da dann typischerweise kein konkurrierender cgi-Parameter vorhanden
    if len(kurs)>0:
        erfolgsmeldung+=a_s.aS.setze_kurs(kurs)
    else:
        klassenname=a_tool.getcgiparameter('klassenname')
        if len(klassenname)>0:
            erfolgsmeldung+=a_s.aS.setze_kurs("@"+klassenname)
    if a_s.aS.aktion>0 and a_s.aS.kurs not in ['Statistik','Gesamtansicht','Maillog','Stammdaten']:
        mcn=mauscursorname[a_s.aS.aktion]
        a_h.merke_header_zeile('''
            <style type="text/css">
                a.tooltip, a.tooltip:link, a.tooltip:visited, a.tooltip:active  {{cursor: url('/ab.img/{mcn}.png'),url('../ab.img/{mcn}.ico'), crosshair; }}
                a.nopointer {{ cursor: url("/ab.img/none.png"), url("../ab.img/none.ico"),default; }}
            </style>'''.format(mcn=mcn))
    thepath=os.path.dirname(os.path.abspath(__file__))
    spielwiese=True if '.dev/' in thepath else False
    
    if spielwiese:
        be='background="/ab.img/spielwiese.png"'
        #be='style="background-color:#BBF;"'
    else:
        be=''
    a_tool.print_file_start(bodyextras=be,mit_zielscroll=True,mit_popups=True) # Druckt alle gemerkten Header und Standardanfänge mit aus
    
    sj_zu_setzen=a_tool.getcgiinteger('sj')
    if sj_zu_setzen>2000:
        a_s.aS.setze_anzeigeschuljahr(sj_zu_setzen)
    undonow=a_tool.getcgiparameter('undonow')
    if undonow=='true':
        erfolgsmeldung+=a_s.undo_absenz()
    highlight=a_tool.getcgiparameter('highlight',"")
    if highlight.isdigit():
        a_s.aS.setze_highlight(int(highlight))
    pid=a_tool.getcgiparameter('pid',"")
    datum=a_tool.getcgiparameter('datum',"")
    if pid.isdigit():
        if a_s.aS.aktion==AKTION_GESPRAECH:
            erfolgsmeldung+=setze_gespraech(int(pid),datum)
        else:
            erfolgsmeldung+=setze_absenz(int(pid),datum)
    monatwert=a_tool.getcgiparameter('monat',"")
    if monatwert.isdigit():
        erfolgsmeldung+=a_s.aS.setze_monat(int(monatwert))
    ks=a_tool.getcgiparameter('ks',"")
    if ks.isdigit():
        erfolgsmeldung+=a_s.aS.setze_ks(int(ks))
    tf_flag=a_tool.getcgiparameter('tagesfilter','')
    if tf_flag.isdigit():
        erfolgsmeldung+=a_s.aS.setze_tagesfilter(int(tf_flag))
        
    ## Statistik: Halbjahresumschaltung
    statsid=a_tool.getcgiparameter('statsid')
    if statsid==str(a_s.aS.sid):
        hj=a_tool.getcgiparameter('hj')[0]
        hjtypen="a12"
        for i in range(3):
            if hj==hjtypen[i]:
                a_s.aS.setze_anzeigehalbjahr(i)
                erfolgsmeldung+='+Halbjahr umgeschaltet auf '+ (str(i) if i else 'beide')
                break
        else:
            erfolgsmeldung+='-Halbjahr nicht umgeschaltet ('+hj+')'
    a_s.aS.berechne_verwaltungszeitraum()
    
    ## Selbstadministration
    erfolgsmeldung+=erledige_useraenderungen()
    
    ## Admin-Tätigkeiten
    if a_s.aS.kuerzel=="admin":
        import a_admin
        erfolgsmeldung+=a_admin.erledige_admin_todo()
        if a_s.aS.sid==a_tool.getcgiinteger('vwsid'):
            import a_verwalter
            erfolgsmeldung+=a_verwalter.erledige_alias_verwaltung()
                
    ########
    #### Bedienpanel oben
    ########
    
    a_tool.prt('<div>\n')
    ## Titel
    logo=a_tool.get_logo()
    if a_s.aS.maxaktion<LEVEL_KRANKMELDUNG:
        a_tool.prt('<div class="b1" style="text-align:center"><h1>Absenzen!</h1>')
        a_tool.prt(logo)
        a_tool.prt('<br><small><small>'+PROGRAMMVERSION+'</small></small></div>\n')
    elif a_s.aS.kuerzel=="admin":
        a_tool.prt('<div class="b1" style="text-align:center;font-size:70%">'+logo+'<br>für<br>Ad-<br>min</div>\n')
    elif a_s.aS.ist_ein_verwalter():
        a_tool.prt('<div class="b1" style="text-align:center">'+logo+'</div>\n')
    else:
        a_tool.prt('<div class="b1" style="text-align:center">'+logo+'<h1>Ab</h1>sen<br>zen</div>\n')
    if a_s.aS.maxaktion>0 and len(a_s.aS.kuerzel)<=6:

        ## Kurs / Anzeige
        ist_realer_kurs=a_db.get_existenz('SELECT kbez FROM kurse WHERE kbez=?',(a_s.aS.kurs,))
        ist_reale_klasse=a_s.aS.kurs[0]=="@" and a_db.get_existenz('SELECT name FROM klassen WHERE name=?',(a_s.aS.kurs[1:],))
        if a_s.aS.kuerzel=='admin':
            a_tool.prt('<div class="bsmall">')
        else:
            a_tool.prt('<div class="b2">')
        anzeigename=a_s.aS.kurs if a_s.aS.kurs[0]!="@" else a_s.aS.kurs[1:]
        a_tool.prt(a_tool.text_lur('Anzeige wählen!','Aktuell:',anzeigename))
    
        kurs=''
        kursliste=''
        anzeigeliste=''
        kursanzahl=0
        if a_s.aS.zeige_reales_schuljahr:
            kursanzahl=a_db.get_first_element('''
                SELECT count(kbez) FROM kurse WHERE klehrer_nr= :nr OR vlehrer_nr= :nr''',{ "nr": a_s.aS.user_nr , },0)
        kurstrenner=int(kursanzahl/2) if kursanzahl>6 else 99
        kurszaehler=0
        if (a_s.aS.ist_seki_in(0) and a_db.get_config_int('flag_tagesliste',0) ) or a_s.aS.ist_ein_verwalter():
            anzeigeliste+='<li><span class="filelink"><a href="a_main.py?popupaktion=tagesliste" target="_blank">Tagesliste</a></span></li>\n'
            
        if a_s.aS.ist_ein_verwalter() or (a_s.aS.ist_seki_in(0) and a_tool.get_gruppenrechte('seki',18)):
            #Statistikbutton für Verwalter oder Seki falls extra berechtigt
            extrastyle='' if 'Statistik'!=a_s.aS.kurs else ' style="color:#117"'
            anzeigeliste+='<li><a href="a_main.py?kurs=Statistik"'+extrastyle+'>Statistik</a></li>\n'
        if a_s.aS.ist_ein_verwalter(): 
            extrastyle='' if 'Gesamtansicht'!=a_s.aS.kurs else ' style="color:#117"'
            anzeigeliste+='<li><a href="a_main.py?kurs=Gesamtansicht"'+extrastyle+'>Gesamtansicht</a></li>\n'
            extrastyle='' if 'Maillog'!=a_s.aS.kurs else ' style="color:#117"'
            anzeigeliste+='<li><a href="a_main.py?kurs=Maillog"'+extrastyle+'>Maillog</a></li>\n'
            extrastyle='' if 'StammdatenS'!=a_s.aS.kurs else ' style="color:#117"'
            anzeigeliste+='<li><a href="a_main.py?kurs=StammdatenS"'+extrastyle+'>StammdatenS</a></li>\n'
            extrastyle='' if 'StammdatenL'!=a_s.aS.kurs else ' style="color:#117"'
            anzeigeliste+='<li><a href="a_main.py?kurs=StammdatenL"'+extrastyle+'>StammdatenL</a></li>\n'
            if a_s.aS.zeige_konfiguriertes_schuljahr:
                if a_s.aS.ist_kurs_verwalter() or a_s.aS.ist_kurs_verwalter():   #Statistikbutton für Verwalter
                    extrastyle='' if 'Kurstage'!=a_s.aS.kurs else ' style="color:#117"'
                    anzeigeliste+='<li><a href="a_main.py?kurs=Kurstage"'+extrastyle+'>Kurstage</a></li>\n'
                if kursanzahl: # Trenner, wenn Verwalterbuttons UND Kursbuttons gezeigt werden
                    anzeigeliste+='<br>'

        if a_s.aS.zeige_konfiguriertes_schuljahr:
            for kurs in a_db.get_column_list('SELECT kbez FROM kurse WHERE klehrer_nr=:nr OR vlehrer_nr=:nr', {"nr":a_s.aS.user_nr,}):
                if kurszaehler==kurstrenner:
                    kursliste+='<br>'
                extrastyle='' if kurs!=a_s.aS.kurs else ' style="color:#117"'
                kursliste+='<li><a href="a_main.py?kurs='+kurs+'"'+extrastyle+'>'+kurs+'</a></li>\n'
                kurszaehler+=1

            klassenliste=a_s.aS.get_klassleiter_klassenliste()
            for klassleiterklasse in klassenliste:
                extrastyle='' if '@'+klassleiterklasse!=a_s.aS.kurs else ' style="color:#117"'
                kursliste+='<li><a href="a_main.py?kurs=@'+klassleiterklasse+'"'+extrastyle+'>'+klassleiterklasse+'</a></li>\n'
                kurszaehler+=1
        
        if len(anzeigeliste)>0: 
            a_tool.prt('<div class="gradientbuttons gverwalter"><ul>'+anzeigeliste+'</ul></div>')
        if len(kursliste)>0: 
            a_tool.prt('<div class="gradientbuttons"><ul>'+kursliste+'</ul></div>')
        
        ist_in_alphabetisch=(a_s.aS.kurs in alphabetisch) or a_s.aS.kurs=="Alle"
        if a_s.aS.maxaktion>=LEVEL_ENTSCHULDIGUNG: #Alphabetische Liste für Verwalter und Sekretariat
            a_tool.prt('\n<div class="gradientbuttons">')
            a_tool.prt('<ul>')
            median=alphabetisch[int(len(alphabetisch)/2)]
            for item in alphabetisch+['Alle']:
                if item=="Aktuelle" and not a_datum.reales_schuljahr()==a_s.aS.anzeigeschuljahr:
                    continue
                extrastyle='' if item!=a_s.aS.kurs else ' style="color:#117"'
                a_tool.prt('<li><a href="a_main.py?kurs='+item+'"'+extrastyle+'>'+item+'</a></li>\n')
                if item[0]==median[0]:
                    a_tool.prt('<br>')
            a_tool.prt('</ul></div>')
        
        ## Klasse wählen
        if a_db.get_config_int('minimum-js')<=20 and a_s.aS.zeige_konfiguriertes_schuljahr:
            seineliste=[]
            for likname in a_db.get_column_list('SELECT kname FROM lehrerinklasse WHERE user_nr=?',(a_s.aS.user_nr,)):
                seineliste.append(likname)
            select='\n<div style=float:left><br><form action="a_main.py" method="get" >'
            
            select+='Klassenwahl:<select name="klassenname">'+str(a_s.aS.von_js)+str(a_s.aS.bis_js)
            
            if a_s.aS.kurs[0]=="@":
                select+='\t<option>'+a_s.aS.kurs[1:]+'</option>'
            else:
                select+='\t<option>-</option>'
            hatklasse=False
            rowdict=a_db.get_rowdict_list('SELECT name,js FROM klassen WHERE js>=? AND js<=? ORDER by js,name ',(a_s.aS.von_js,a_s.aS.bis_js))
            for row in rowdict:
                if  ( row["js"]>0 and a_s.aS.ist_berechtigt_in[row["js"]] ) or \
                    ( row["name"] in seineliste) :
                        select+='\t<option>'+row[0]+'</option>'
                        hatklasse=True
            select+='</select>'
            select+='<input value="Anzeigen" type="submit"></form></div>\n'
            if hatklasse:
                a_tool.prt(select)
        ## Kurs wählen
        if (a_s.aS.ist_kurs_verwalter() or a_s.aS.ist_kurs_verwalter() ) and a_s.aS.zeige_konfiguriertes_schuljahr:
            select='\n<div style=float:right><br><form action="a_main.py" method="get"  width="48%">'
            select+='Kurswahl:<select name="kurs">'
            selectlist=[]
            firstitem=a_s.aS.kurs if ist_realer_kurs else '-'
            select+='\t<option>'+firstitem+'</option>'
            for kbeze in a_db.get_column_list('SELECT kbez FROM kurse ORDER by kbez'):
                selectlist.append('\t<option>'+kbeze+'</option>')
            select+=''.join(selectlist)+'</select>'
            select+='<input value="Anzeigen" type="submit"></form></div>'
            a_tool.prt(select)
        ## Terminverwaltung und Schulaufgabenplan
        if a_db.get_config_int('flag_termineanzeigen',0):
            a_tool.prt('<br><div style="width:100%"><div class=" gradientbuttons gtermine" style="text-align:center;margin-top:5px;">')
            a_tool.prt('<a href="a_termine.py?grab=ql">Terminliste</a>')
            if a_s.aS.ist_terminverwalter() or a_s.aS.ist_kurs_verwalter() and a_s.aS.zeige_reales_schuljahr:
                a_tool.prt('<a href="a_termine.py?verwalten=1">Terminverwaltung</a>')
            a_tool.prt('<br>')
            a_tool.prt('<a href="a_termine.py?showclassicview=1">Zum Schulaufgabenplan</a></div></div>')
        
        a_tool.prt('</div>\n') #Ende des Kastens "Anzeige"
        
        if ist_realer_kurs or ist_reale_klasse or ist_in_alphabetisch:
            ## Aktionen
            if a_s.aS.kuerzel=='admin':
                a_tool.prt('<div class="bsmall" style="width:35em;">')
            else:
                a_tool.prt('<div class="b2" style="width:35em;">')
            halbtagsinfo= ' ½-tags' if a_s.aS.aktion==LEVEL_ENTSCHULDIGUNG and a_s.aS.get_halbtagsflag() else ''
            a_tool.prt(a_tool.text_lur('Aktion wählen!','Aktuell:',STATUSSTRG[a_s.aS.aktion]+halbtagsinfo))
            erledige_aktionen_auswahl()
            a_tool.prt('</div>\n')
        
        
    ## Useranmeldung
    kuerzelnennung=a_s.aS.kuerzel if len(a_s.aS.kuerzel)<=6 else ""
    a_tool.prt('<div class="b3">Angemeldet: <b>'+a_s.aS.klarname+'</b> '+kuerzelnennung+'<br>')
    erfolgsmeldung+=erledige_userdialog()
    a_tool.prt('</div>')

    if a_s.aS.maxaktion>0 and len(a_s.aS.kuerzel)<=6:
        
        ## Monat wählen
        if a_s.aS.kuerzel=='admin':
            a_tool.prt('<div class="bsmall">')
        else:
            a_tool.prt('<div class="b3">')
        a_tool.prt(a_tool.text_lur('Monat wählen!','Aktuell:',monatsname[a_s.aS.monat]))
        a_tool.prt('\n<div class="gradientbuttons">')
        a_tool.prt('<ul>')
        vor= (a_s.aS.monat -1) if a_s.aS.monat>1 else 12
        nach=(a_s.aS.monat +1) if a_s.aS.monat<12 else 1
        for i in [vor,a_s.aS.monat,nach]:
            extrastyle='' if i!=a_s.aS.monat else ' style="color:#117"'
            if i!=8:
                a_tool.prt('<li><a href="a_main.py?monat='+str(i)+'"'+extrastyle+'>'+monatsname[i]+'</a></li>\n')
        if a_s.aS.ist_ein_verwalter():
            a_tool.prt('<br><span style="font-size:70%">')
            for i in [10,2,6]:
                a_tool.prt('<li><a href="a_main.py?monat='+str(i)+'">'+monatsname[i]+'</a></li>\n')
            a_tool.prt('</span>')
            
        a_tool.prt('</ul>')
        a_tool.prt('</div>\n')
        
        ## anzuzeigendes Schuljahr wählen
        if a_s.aS.ist_ein_verwalter():
            sj=["","",""]
            for i in range(3):
                sj[i]=a_s.aS.get_lesbares_schuljahr(i-1) # also für -1,0,+1
            
            a_tool.prt(a_tool.text_lur('anzuzeigendes Schuljahr!','Aktuell:',sj[1]))
            a_tool.prt('\n<div class="gradientbuttons">')
            a_tool.prt('<ul>')
            for i in range(3): # alle Wahlmöglichkeiten durchgehen
                extrastyle='' if i!=1 else ' style="color:#117"' # ist es das gewählte? schwarze Schrift!
                a_tool.prt('<li><a href="a_main.py?sj='+str(sj[i])[:4]+'"'+extrastyle+' title="'+sj[i]+'">'+sj[i]+'</a></li>\n')
            a_tool.prt('</ul></div>\n')
            
        ## Jahrgangsstufe wählen
        if a_s.aS.ist_ein_verwalter() and not ist_realer_kurs:
            minimum_js=a_db.get_config_int('minimum-js') # kleinste vorkommende Jahrgangsstufe im Datenbestand
            
            a_tool.prt(a_tool.text_lur('Jahrgangsstufenfilter!','Aktuell:',a_js.get_ks(a_s.aS.stufe).name))
            a_tool.prt('\n<div class="gradientbuttons">')
            a_tool.prt('<ul>')
            
            for i in [1,2,3]+list(range(20,26)): # alle Wahlmöglichkeiten durchgehen
                if a_js.get_ks(i).beginn>0:
                    extrastyle='' if i!=a_s.aS.stufe else ' style="color:#117"' # ist es das gewählte? schwarze Schrift!
                    
                    if (a_s.aS.ist_verwalter_in(i)) and minimum_js<=a_js.get_ks(i).ende and a_js.get_ks(i).name: # darf er und gibt es dort Klassen?
                        a_tool.prt('<li><a href="a_main.py?ks='+str(i)+'"'+extrastyle+'>'+a_js.get_ks(i).name+'</a></li>\n')
            a_tool.prt('</ul></div>\n')
        ## Tagesfilter schalten
        if ist_realer_kurs and a_s.aS.zeige_konfiguriertes_schuljahr:
            
            a_tool.prt(a_tool.text_lur('Wochentagsfilter!','Aktuell:',('Aus','An','An+')[a_s.aS.get_tagesfilter()%3]))
            a_tool.prt('\n<div class="gradientbuttons">')
            a_tool.prt('<ul>')
            extrastyle=' style="color:#117"' if not a_s.aS.get_tagesfilter() else '' # ist es das gewählte? schwarze Schrift!
            a_tool.prt('<li><a href="a_main.py?tagesfilter=0" '+extrastyle+' title="Alle Schultage werden angezeigt">Aus</a></li>\n')
            extrastyle=' style="color:#117"' if a_s.aS.get_tagesfilter()==1 else '' # ist es das gewählte? schwarze Schrift!
            a_tool.prt('<li><a href="a_main.py?tagesfilter=1" '+extrastyle+' title="Nur die Tage,\nan denen der Kurs stattfindet,\nwerden angezeigt">An</a></li>\n')
            extrastyle=' style="color:#117"' if a_s.aS.get_tagesfilter()==2 else '' # ist es das gewählte? schwarze Schrift!
            a_tool.prt('<li><a href="a_main.py?tagesfilter=2" '+extrastyle+' title="zusätzlich werden alle Tage\nab September bzw. Januar angezeigt">An+Vormonate</a></li>\n')
            a_tool.prt('</ul>')
            a_tool.prt('</div>\n')

        
        a_tool.prt('</div>\n')



    a_tool.prt('</div>\n')
    a_tool.prt('<div style="clear:left"></div>')
    #### Ende Bedienpanel
    ## Verwalteraufgabe
    if a_s.aS.kurs=='Kurstage' and (a_s.aS.ist_kurs_verwalter() or a_s.aS.ist_kurs_verwalter()):
        import a_verwalter
        erfolgsmeldung+=a_verwalter.kurstage_verarbeitung()
        
    ## Erfolgs- und Fehlermeldungen
    eem=a_tool.getcgiparameter('externeerfolgsmeldung',"")
    if len(erfolgsmeldung)==0:      erfolgsmeldung=eem
    elif len(eem)>0:                erfolgsmeldung+='<br>'+eem
    a_tool.prt(a_h.erfolgsmeldung2html(erfolgsmeldung)) # fixe Höhe
    if fehlerliste:
        a_tool.prt('<pre  style="background:yellow;">Aufgetretene Fehler:\n'+fehlerliste+'</pre>') # variable Höhe
    ## Administratorinterface
    if a_s.aS.kuerzel=="admin":
        a_admin.erledige_admin_dialog()
    a_tool.prt('<div style="clear:left"></div>')
    
    if a_s.aS.maxaktion>0:     
        if a_s.aS.kurs=='Statistik' and (a_s.aS.ist_ein_verwalter() or (a_s.aS.ist_seki_in(0) and a_tool.get_gruppenrechte('seki',18))):
            import a_verwalter
            toprint=a_verwalter.statistiktabelle()
        elif a_s.aS.kurs=='Gesamtansicht' and a_s.aS.ist_ein_verwalter():
            import a_verwalter
            toprint=a_verwalter.gesamtansicht()
        elif a_s.aS.kurs=='Maillog' and a_s.aS.ist_ein_verwalter():
            import a_verwalter
            toprint=a_verwalter.mailprotokoll()
        elif a_s.aS.kurs=='StammdatenS' and a_s.aS.ist_ein_verwalter():
            import a_verwalter
            toprint=a_verwalter.stammdatenanzeige_schueler()
        elif a_s.aS.kurs=='StammdatenL' and a_s.aS.ist_ein_verwalter():
            import a_verwalter
            toprint=a_verwalter.stammdatenanzeige_lehrer()
        elif a_s.aS.kurs=='Kurstage' and (a_s.aS.ist_kurs_verwalter() or a_s.aS.ist_kurs_verwalter()):
            import a_verwalter
            toprint=a_verwalter.kurstage_dialog()
        else:
            import a_tabelle
            toprint=a_tabelle.absenzentabelle(monat=a_s.aS.monat,praefix=a_s.aS.kurs)
        a_tool.prt(toprint)
        a_tool.prt('\n<div class="b2"><h3>Verlauf: <small> <small> (neueste Einträge oben) </small></small></h3>'+a_s.aS.verlauf+'</div>')
    else:
        a_tool.prt('<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="/ab.img/absenzen_anleitung.png" />')

    a_tool.prt('</body>\n</html>\n')
    a_tool.prt('<!-- Statistik Commits: '+a_db.get_commit_stat()+' -->')



cookiekuerzel=''
#### Der formale Start, außer es wurde als Modul geladen:
if __name__ == '__main__':
    starttime=time.time()
    initmeldung=""
    absentmain()
    a_tool.prt('\n<!-- Rechenzeit auf dem Server:'+str(time.time()-starttime)[:5]+' Sekunden -->')
else:
    initmeldung,cookiekuerzel=a_s.check_session()
    
