#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_user.py                                                        
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_user.py stellt Tools für die anderen absenzen-Module zur Verfügung
  Schwerpunkt: Anlegen und Verändern von Personen(-daten)
________________________________________________________________________
'''

import a_tool, a_db, a_session as a_s
import a_js, a_h, a_datum

def get_user(user_nr):
    return a_db.get_one_rowdict('SELECT * FROM users WHERE user_nr=?',(user_nr,))
    
def select_dialog():
    ausgabe=[]
    select=['<select name="user_nr">']
    select.append('\t<option>-</option>')
    for name,pid in a_db.get_rowdict_list('''
        SELECT klarname,user_nr 
        FROM users
        ORDER BY sortiername'''):
        select.append('\t<option value={}>{}</option>'.format(str(pid),name))
    select.append('</select>')
    ausgabe.append('''<div class="umrahmterhellt"><b>Einstellungen von Benutzer(in)</b>
        <form action="a_user.py" method="post" onsubmit="target_popup(this)">
        '''+'\n'.join(select)+'''
        <input value="bearbeiten!" type="submit">
        <input name="uesid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br></form></div>''')
    
    ausgabe.append('''<div class="umrahmterhellt"><b>Neue(n) Benutzer(in)</b>
        <form action="a_user.py" method="post" onsubmit="target_popup(this)">
        <input name="neueruser" type="text" size="12" maxlength="20" />
        <input value="anlegen!" type="submit">
        <input name="uesid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br></form></div>''')
        
    ausgabe.append('<div class="umrahmterhellt"><b>Passwörter ausgeben:</b> (nur generierte)<br>')
    ausgabe.append('''<div class="gradientbuttons filelink" style="text-align:right">  <a href="a_main.py?popupaktion=lehrercodes" target="_blank" title="Öffnet sich in neuem Fenster">
            Passwörter als csv-Datei</a><br>''')
    ausgabe.append('''  <a href="a_main.py?popupaktion=lehrerbrief" target="_blank" title="Öffnet sich in neuem Fenster">
            Serien-Passwort-Brief</a></div></div>''')
    
    ausgabe.append('</div>')    
    return '\n'.join(ausgabe)

def aendern_dialog():
    ausgabe=[]
    user_nr=a_tool.getcgiinteger('user_nr',neue_user_nr)
    try:
        user=get_user(user_nr)
        klarname=user["klarname"]
    except:
        return "Kein User ausgewählt - Schließen Sie das Fenster"
    
    #Passwortänderung
    ausgabe.append('<h2>Anwender {}</h2>'.format(klarname))
    ausgabe.append('<div class="umrahmterhellt"><h3>Passwort ändern:</h3>')
    ausgabe.append('''<form action="a_user.py" method="post" >
        neues Passwort: <input name="neuespasswort1" size="5" maxlength="20" type="password" >&nbsp;
        bitte wiederholen: <input name="neuespasswort2" size="5" maxlength="20" type="password" ><br>
        <input value="ändern" type="submit">
        <input name="user_nr" value="{user_nr}" type="hidden">
        <input name="uesid" value="{uesid}" type="hidden"></form></div>'''.format(uesid=str(a_s.aS.sid),user_nr=str(user_nr)))
        
    ## Klassenzuweisung
    ausgabe.append('<div class="umrahmterhellt"><h3>Klassen</h3>...in denen unterrichtet wird.<br>Wird beim nächsten Einlesen wieder überschrieben!')
    spalte=a_db.get_column_list('''
            SELECT kname
            FROM lehrerinklasse
            WHERE user_nr=?
            ORDER BY kname''',(user_nr,))
    ausgabe.append('<br>Aktueller Einsatz in: '+', '.join(spalte)+'<br>')
    spalte=a_db.get_column_list('''
            SELECT name
            FROM klassen 
            WHERE name NOT IN (SELECT kname FROM lehrerinklasse WHERE user_nr=?)
            ORDER BY name''',(user_nr,))
    select=['<select name="eiklasse">']  # für klasse
    select.append('\t<option>-</option>')
    for eiklasse in spalte:
        select.append('\t<option>'+eiklasse+'</option>')
    select.append('</select>')
    ausgabe.append('''<form action="a_user.py" method="post">
        {selektor}
        <input value="zuordnen" type="submit">
        <input name="user_nr" value="{user_nr}" type="hidden">
        <input name="uesid" value="{uesid}" type="hidden"><br></form></div>'''.format(selektor='\n'.join(select),uesid=str(a_s.aS.sid),user_nr=str(user_nr)))
    
    ## Rechtevergabe
    ausgabe.append('''<div class="umrahmterhellt"><h3>Rechtevergabe</h3>
                    <form action="a_user.py" method="post" style="text-align:right">''')
    
    minimumjs=a_db.get_config_int('minimum-js')
    benennung=['',a_js.get_ks(1).name,a_js.get_ks(2).name,a_js.get_ks(3).name,'Kurse']
    inputname=['','grechte',          'urechte',          'mrechte',          'orechte']
    radiotext=['keine','Stufenlehrer','Seki','Verwalter']
    radiowert=["0",    "2",           "4",   "9"]
    userrechte=a_tool.get_user_rechte(user_nr)+'----'
    for stufe in range(1,5):
        if (stufe<4  and minimumjs<=a_js.get_ks(3).ende) or \
           (stufe==4 and a_js.get_kj(1).name):
            ausgabe.append(benennung[stufe]+':&nbsp;&nbsp;&nbsp;')
            for i in range(4):
                ausgabe.append('<input type="radio" name="{inputname}" value="{radiowert}" {ischecked}>{radiotext}&nbsp;&nbsp;&nbsp;'.format( \
                inputname=inputname[stufe],
                radiowert=radiowert[i], radiotext=radiotext[i],
                ischecked= 'checked' if userrechte[stufe-1]==radiowert[i] else ''))
            ausgabe.append('<br>')
        
    ausgabe.append('''    <input value="festlegen!" type="submit">
        <input name="rechteaenderung" value="1" type="hidden">
        <input name="user_nr" value="{user_nr}" type="hidden">
        <input name="uesid" value="{uesid}" type="hidden"></form></div>'''.format(uesid=str(a_s.aS.sid),user_nr=user_nr))
    
    return '\n'.join(ausgabe)
    

def admin_doit(): # wird nur aufgerufen, wenn der User schon als Admin identifiziert wurde
    global neue_user_nr
    ea_erfolg=''
    ## Neuer User
    neueruser=a_tool.bereinige_name(a_tool.getcgiparameter('neueruser'))
    if len(neueruser)>2:
        user_nr=a_tool.lege_user_an(neueruser)
        if user_nr>0:
            ea_erfolg+='+'+neueruser+' angelegt. '
            neue_user_nr=user_nr
        else:
            ea_erfolg+='-'+neueruser+' konnte nicht angelegt werden. '

    user_nr=a_tool.getcgiparameter('user_nr')
    der_user=get_user(user_nr)
    if der_user:
        klarname=der_user["klarname"]
        kuerzel=der_user["kuerzel"]
        ## Passwortänderung
        neuespasswort=a_tool.getcgiparameter('neuespasswort1')
        if neuespasswort:
            if len(neuespasswort)>=4:
                if neuespasswort==a_tool.getcgiparameter('neuespasswort2'):
                    ea_erfolg+=a_tool.setze_user_passwort(user_nr,kuerzel,neuespasswort)
                else:
                    ea_erfolg+='-Passwörter stimmen nicht überein'
            else:
                ea_erfolg+='-Passwort zu kurz'
        ## Klassenzuweisung
        eiklasse=a_tool.getcgiparameter('eiklasse')
        
        if eiklasse:
            if a_db.get_existenz('SELECT name FROM klassen WHERE name=?',(eiklasse,)):
                a_db.execute('INSERT INTO lehrerinklasse VALUES (?,?)',(eiklasse,user_nr))
                ea_erfolg+='+{n} unterrichtet nun auch in {k}'.format(n=klarname,k=eiklasse)
            else:
                ea_erfolg='-Klasse {} existiert nicht'.format(eiklasse)
                
        ## Rechtevergabe
        if a_tool.getcgiinteger('rechteaenderung')==1:
            grechte=a_tool.getcgiparameter('grechte')
            urechte=a_tool.getcgiparameter('urechte')
            mrechte=a_tool.getcgiparameter('mrechte')
            orechte=a_tool.getcgiparameter('orechte')
            
            neurechte=''
            legalewerte=["2","4","9"]
            neurechte += grechte if grechte in legalewerte else "0"
            neurechte += urechte if urechte in legalewerte else "0"
            neurechte += mrechte if mrechte in legalewerte else "0"
            neurechte += orechte if orechte in legalewerte else "0"
            a_tool.setze_user_rechte(user_nr,neurechte)
            ea_erfolg+="+Lehrerstatus von "+klarname+" neu gesetzt auf "+neurechte #+' wegen '+grechte+urechte+mrechte+orechte
         
    return ea_erfolg
    
neue_user_nr=0

if __name__ == '__main__':
    meldung="Unzulässiger Aufruf oder Session abgelaufen"
    uesid=a_tool.getcgiparameter("uesid")
    a_s.check_session()
    sid=str(a_s.get_session().sid)
    a_tool.print_file_start(head='<meta http-equiv="refresh" content="610; URL=a_user.py" />',
                            bodyextras='style="background:#ADA;padding:1em;"')
    resultat=''
    if uesid==sid and a_s.aS.kuerzel=='admin':
        resultat=admin_doit()
        a_tool.prt(a_h.erfolgsmeldung2html(resultat))
        a_tool.prt(aendern_dialog())
    else:
        a_tool.prt('<h1>'+meldung+'</h1>')
    a_tool.prt('</body>')

    
