#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_verwalter.py                                                       
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_verwalter.py beinhaltet den Code für Verwaltertätigkeiten
 Dieses Modul wird nicht geladen, wenn der user kein Verwalter ist.
________________________________________________________________________
'''

from a_konstanten import *

import a_session as a_s
import a_tool
import a_db
import a_js
import a_datum



verschmelzmaster=0

def get_tagesliste(tageslistendatum=""):
    session=a_s.get_session()
    if session.maxaktion<LEVEL_ENTSCHULDIGUNG:
        return '<h2>Unzulässiger Statistik-Abruf!</h2>'
    jetzt=a_datum.get_jetzt()
    heute=a_datum.get_heutedatum()
    if tageslistendatum=="":
        tageslistendatum=heute
    vergangenheit= (heute!=tageslistendatum)
    kopf,seite,fuss,seitenseparator=a_tool.lese_htmlvorlage_ein('tagesliste.html')
    # Zuerst alle Namen und ihre PID holen
    rowdict_list=a_db.get_rowdict_list('''
        SELECT  personen.name,personen.klasse,status,kommentar
        FROM    personen,absenzen
        WHERE personen.pid==absenzen.pid AND absenzen.datum==? AND status>0
        ORDER BY js, klasse,sortiername''',(tageslistendatum,))
    liste=['<table><tr><th>Klasse</th><th>Name</th></tr>\n']
    for name,klasse,status,kommentar in rowdict_list:
        if status==LEVEL_SCHULBEFREIUNG:
            if '"' in kommentar: # nun soll (nur) der letzte in "" eingeklammerte Kommentar angehängt werden
                letzter=kommentar.rfind('"')
                vorletzter=kommentar.rfind('"',0,letzter) if letzter>0 else -1
                if vorletzter>0:    neukommentar=' '+kommentar[vorletzter:letzter+1]
                else:               neukommentar=''
            else: neukommentar=""
            if '(' in kommentar: # nun soll (nur) der letzte in () eingeklammerte User angehängt werden
                letzter=kommentar.rfind(')')
                vorletzter=kommentar.rfind('(')
                if vorletzter>0 and vorletzter<letzter: 
                    neukommentar+=' '+kommentar[vorletzter:letzter+1]
        else: neukommentar=''
        liste.append('<tr><td>'+klasse+'</td><td>'+name+'</td><td>'+STATUSSTRG[status]+neukommentar+'</td></tr>\n')
    liste.append('</table>\n')
    if vergangenheit:
        seite=seite.replace('ABTAGESKOPF','Fehlende Schüler am '+a_datum.isodatum2datum(tageslistendatum))
    else:
        seite=seite.replace('ABTAGESKOPF','Heute fehlende Schüler')
    datei=kopf+seite.replace('ABTAGESLISTE',"".join(liste)).replace('ABTAGESZEIT',jetzt)+fuss
    return datei
    
def gesamtansicht(absenzenbrief=False,datumsstart="2000-01-01",datumslimit="9999-99-99",mitauswahl=True,einzelschueler=0):
    '''Gibt für alle Schüler eine (unstrukturierte, 
    aber sortierte) Liste ihrer Absenzen aus. 
    Mit Parameter absenzenbrief=True aufgerufen wird stattdessen ein HTML-Serienbrief erzeugt!'''
    import a_tabelle
    session=a_s.get_session()
    if not session.genug_rechte(RECHTE_ABSENZENBLATT):
        return '<h2>Unzulässiger Statistik-Abruf!</h2>'
    heute=min(a_datum.get_heutedatum(),datumslimit)
    if absenzenbrief:
        kopf,seite,fuss,seitenseparator=a_tool.lese_htmlvorlage_ein('absenzenbrief.html')
    # Zuerst alle Namen und ihre PID holen
    if einzelschueler>0:
        rowdict_list=a_db.get_rowdict_list('''
            SELECT  personen.pid,name,js,klasse,apdatum
            FROM    personen
            WHERE   pid=?''',(einzelschueler,))
    else:
        if absenzenbrief:
            rowdict_list=a_db.get_rowdict_list('''
                SELECT  personen.pid,name,js,klasse,apdatum
                FROM    personen
                WHERE   js BETWEEN ? AND ?
                ORDER BY js,klasse,sortiername''',(session.von_js,session.bis_js))
        else:
            rowdict_list=a_db.get_rowdict_list('''
                SELECT  personen.pid,name,js,klasse,apdatum
                FROM    personen
                WHERE   js BETWEEN ? AND ?
                ORDER BY sortiername''',(session.von_js,session.bis_js))
    pliste=[]
    for row in rowdict_list:
        pid,name,js,klasse,apdatum=row
        pliste.append([pid,name,js,klasse,apdatum])
    #Tabelle beginnen
    if absenzenbrief:
        brief=kopf
        ersterschueler=True
    else:
        ausgabe='<div class="b1">'
        if mitauswahl:
            ausgabe+='''
                <div class="filelink" style="float:left;">
                    <form action="a_main.py" method="post" target="_blank">
                        Diese Statistik in eigenem Fenster <input value="ausgeben" type="submit">
                        <input name="popupaktion" value="gesamtansicht" type="hidden">
                    </form>
                </div>
                <div style="float:left;width:3em;text-align:center;"> - </div>
                <div class="filelink" style="float:left;">
                    <form action="a_main.py" method="post">
                        Bis zum <input name="datumslimit" size="10" maxlength="12" value="'''+heute+'''"> als Serienbrief 
                        <input value="ausgeben" type="submit">
                        <input name="popupaktion" value="absenzenbrief" type="hidden">
                    </form>
                </div>
                <div style="float:left;width:3em;text-align:center;"> - </div>
                <div style="float:left">Einzelbrief mit Klick auf den Namen!</div>
                <div style="clear:left;"></div>'''
        else:
            if session.von_js!=session.bis_js:
                umfang=a_js.get_kj(session.von_js).name+' bis '+a_js.get_kj(session.bis_js).name
            else:
                umfang=a_js.get_kj(session.von_js).name
            ausgabe+='<h3>Gesamtansicht der Absenzen der '+umfang+', Stand: '+heute+'</h3>'
                
        ausgabe+='''
            <table>
                <tr>
                    <th>Name</th>
                    <th>Fehl-<br>tage</th>
                    <th>Quo-<br>te</th>
                    <th>un-<br>ent.</th>
                    <th>fehl.<br>Att.</th>
                    <th>Liste aller Absenzen</th>
                </tr>\n'''
            
    
    #Jetzt die Liste aller Namen abklappern und Statistik und alle Absenzen in die Tabelle einzufügen
    for [pid,name,js,klasse,apdatum] in pliste:
        if not (session.ist_verwalter_in(js) or session.genug_rechte(RECHTE_ABSENZENBLATT)):
            continue
        # Hier geht ein neuer Schüler los! Daten einlesen und Zeilenanfang bzw. Kopf anlegen
        infohalbjahre=''
        est=a_tabelle.get_einzelstatustabelle(pid,js,apdatum,datumslimit=datumslimit)
        if est.mitte2:
            infohalbjahre='<p style="margin-left:2em;font-size:80%;">Verteilung auf die Halbjahre:</p>'
            for i in range(1,3):
                infohalbjahre+='<p style="margin-left:4em;font-size:80%;">'
                if i==1:
                    infohalbjahre+='bis zum '+a_datum.isodatum2datum(est.mitte1)
                else:
                    infohalbjahre+='&nbsp;ab dem '+a_datum.isodatum2datum(est.mitte2)
                infohalbjahre+=': Fehltage: '+str(est.absenzen[i])+' von '+str(est.schultage[i])+' ('+str(est.quote[i])+'%) davon ganztägig: '+str(est.ganztaegige[i])+ \
                    '. Unentsch. sind: '+str(est.unentschuldigt[i]) +'. Fehl. Atteste: '+str(est.attestfehlt[i])+'</p>'
        else:
            infohalbjahre=''
        absenzen_nach_wochentagen=[0,0,0,0,0,0,0]
        
        if absenzenbrief:
            sj=a_datum.reales_schuljahr()
            einzelseite=      seite.replace('SCHUELERNAME',         name+' ('+klasse+')')
            einzelseite=einzelseite.replace('ABINFOHEUTE',          a_datum.isodatum2datum(heute))
            einzelseite=einzelseite.replace('ABINFOSJ',             str(sj)+'/'+str(sj+1))
            einzelseite=einzelseite.replace('ABINFOABSENZEN',       str(est.absenzen[0])+' von '+str(est.schultage[0]))
            einzelseite=einzelseite.replace('ABINFOUNENTSCHULDIGT', str(est.unentschuldigt[0]))
            einzelseite=einzelseite.replace('ABINFOATTESTFEHLT',    str(est.attestfehlt[0]))
            einzelseite=einzelseite.replace('ABINFOGANZTAEGIGE',    str(est.ganztaegige[0]))
            einzelseite=einzelseite.replace('ABINFOQUOTE',  str(est.quote[0]))
            
            if infohalbjahre:
                einzelseite=einzelseite.replace('<!-- ABINFOHALBJAHRE -->', infohalbjahre)
            abinfoliste=""
            abganztaegigeliste=""
        else:
            if mitauswahl:
                ausgabe+='\t\t<tr><td><a href="a_main.py?popupaktion=absenzenbrief;einzelschueler='+str(pid)+'" target="_blank">'+name+' <span style="float:right">('+klasse+')</span></a></td>'
            else:
                ausgabe+='\t\t<tr><td>'+name+' <span style="float:right">('+klasse+')</span></td>'
            ausgabe+=est.ergebnis+'<td style="font-family:Arial-Narrow;font-size:80%">'
        # Info über Attestpflicht
        if len(apdatum)==10 and apdatum<'9999-99-99':
            if absenzenbrief:
                abinfoliste+='<b>Attestpflicht seit '+a_datum.isodatum2datum(apdatum)+'</b><br>\n'
            else:
                ausgabe+='<small>(Attestpflicht seit '+a_datum.isodatum2datum(apdatum)+')</small> '
        
        # Jetzt seine Absenzen einlesen
        rowdict_list=a_db.get_rowdict_list('''
            SELECT  status, attestpflicht, datum, teilflag
            FROM    absenzen
            WHERE   pid=? AND status>=?
              AND   datum>=? AND datum<=?
            ORDER BY datum''',(pid,LEVEL_VERMISST,datumsstart,datumslimit))
        komma=""
        jahr=""
        monat=""
        monatszahl,monatsatteste=-1,0  # FIXME - ein unverifizierter Workaround - warum -1 nötig, wenn 0 logisch wäre? Vermutung: Erster Monatswechsel macht Probleme
        # Nun durchläuft es alle Absenzen dieses Schülers
        for row in rowdict_list: 
            status, attestpflicht, datum, teilflag = row
            monatszahl+=1
            absenzen_nach_wochentagen[a_datum.wochentag(datum)]+=1
            if jahr=="" or jahr!=datum[:4]:
                komma=""
                monat=""
                altjahr=jahr
                jahr=datum[:4]
                if absenzenbrief:
                    if altjahr!="":
                        abinfoliste=abinfoliste.replace('ABSTATPLACEHOLDER',monatsstatistik(monatsatteste,monatszahl))+'</td></tr>'
                        abinfoliste+='</table>\n'
                        monatszahl,monatsatteste=1,0
                        abganztaegigeliste+='</p>'
                    abinfoliste+='<h4>'+jahr+':</h4><table><tr>'
                    abganztaegigeliste+=jahr+': '
                else:
                    if altjahr!="":
                        ausgabe+='&nbsp;&nbsp;'
                    ausgabe+='<b><u>'+jahr+':</u></b> '
            if absenzenbrief:
                if monat=="" or monat!=datum[5:7]:
                    altmonat=monat
                    komma=""
                    monat=datum[5:7]
                    if monat.isdigit:
                        if altmonat!="":
                            abinfoliste=abinfoliste.replace('ABSTATPLACEHOLDER',monatsstatistik(monatsatteste,monatszahl))+'</td></tr>'
                            monatszahl,monatsatteste=1,0
                        abinfoliste+='<tr><td>&nbsp;&nbsp;'+monatsname[int(monat)]+ \
                        ''':</td>
                        <td class="numbers" style="white-space: nowrap;text-align:right;margin-left:1em;margin-right:1em;">ABSTATPLACEHOLDER</td>
                        <td class="numbers">'''
                    
            
            pre=''; post=''
            if status<LEVEL_ATTESTOK and (attestpflicht or (len(apdatum)==10 and datum>=apdatum)):
                pre='<b>'
                post='</b> (Attest fehlt)'
                if teilflag:
                    pre+='<i>'
                    post='</i>'+post
            elif status<LEVEL_ENTSCHULDIGUNG:
                pre='<b>'
                post='</b> (Entsch. fehlt)' if absenzenbrief else '</b> (Ents.fehlt)' 
            elif teilflag:
                pre+='<small><i>'
                post='</i></small>'+post
            if absenzenbrief:
                if  status==LEVEL_ATTESTOK:
                    monatsatteste+=1
                    pre+='<u>'
                    post='</u>'+post
                abinfoliste+=komma+pre+a_datum.isodatum2datum(datum)[:6]+post
                if not teilflag:
                    abganztaegigeliste+=komma+a_datum.isodatum2datum(datum)[:6]
            else:
                ausgabe+=komma+pre+a_datum.isodatum2datum(datum)[:6]+post                
            komma=", "
        
        #Nun den Schüler abschließen:
        if absenzenbrief:
            abinfoliste=abinfoliste.replace('ABSTATPLACEHOLDER',monatsstatistik(monatsatteste,monatszahl))+'</td></tr></table>'+ \
                '''<small><small><br>
                (Legende<br>Monat: '''+ \
                ('&nbsp;&nbsp;[ <u>mit A.</u>+ohne A.=alle ]&nbsp;&nbsp; ' if zeige_monatsstatistik else '') + \
                '''<i>halbtägig</i>, ganztägig, <u>mit Attest</u>, <b>unvollständig</b>)
                </small></small>'''

        wota_statistik=""
        wota_space=" " if absenzenbrief else ""
        wota_komma=", " if absenzenbrief else ","
            
        for i in range(7):
            if i<5 or absenzen_nach_wochentagen[i]:
                if i:
                    wota_statistik+=wota_komma
                wota_statistik+=wotage[i]+":"+wota_space+str(absenzen_nach_wochentagen[i])
                
        if absenzenbrief:
            einzelseite=einzelseite.replace('ABINFOWOTA',wota_statistik)
            einzelseite=einzelseite.replace('ABINFOLISTE',abinfoliste)
            einzelseite=einzelseite.replace('ABGANZTAEGIGELISTE',abganztaegigeliste)
            if ersterschueler:
                ersterschueler=False
            else:
                brief+=seitenseparator
            brief+=einzelseite
            #if einzelschueler:
                #brief+=seitenseparator
            brief+=a_tabelle.schueler_kalender(pid,datumslimit)
        else:
            ausgabe+=' Verteilung: '+wota_statistik+'</td></tr>\n'
        
    #Jetzt die gesamte Datensammlung abschließen
    if absenzenbrief:
        brief+=fuss
        return brief
    ausgabe+='\t</table>\n</div>\n'
    return ausgabe
    
def monatsstatistik(monatsatteste,monatszahl):
    if not zeige_monatsstatistik:
        return ' '
    ausgabe='[<u>{:2}</u>+{:2}={:2}]'.format(monatsatteste,monatszahl-monatsatteste,monatszahl)
    #ausgabe='[ <u>'+str(monatsatteste)+'</u>+'+str(monatszahl-monatsatteste)+'='+str(monatszahl)+' ]'
    return ausgabe
    
def mailprotokoll():
    session=a_s.get_session()
    if not session.ist_ein_verwalter():
        return '<h2>Unzulässiger Protokoll-Abruf!</h2>'
    ausgabe='''<div class="b1">
    <form action="a_main.py" method="post" target="_blank" style="float:left;height:1.8em;" title=
        "Sie können hiermit eine harmlose Testmail versenden.\nFehlermeldungen werden sofort angezeigt und im Maillog vermerkt.\nEin Kopie der Testmail und eine Bestätigung bei Erfolg geht auch an das Administratorkonto!">
        Testmail <input value="verschicken" type="submit">
        <input name="popupaktion" value="mailtest" type="hidden">
    </form>
    <form action="a_main.py" method="post" target="_blank" style="float:left;height:1.8em;" title=
        "Sie können hiermit alle Emails abholen lassen.\nErfolgs- und Fehlermeldungen werden sofort angezeigt und im Maillog vermerkt.\n<b>Vorsicht:</b>Es werden alle (auch Schüler-) Mails verarbeitet!\nEin gleichzeitiges Ausführen mit dem automatischen Abholen kann zu race-conditions führen!">
        Mails testweise <input value="abholen" type="submit">
        <input name="popupaktion" value="poptest" type="hidden">
    </form>
    <form action="a_main.py" method="post" target="_blank" style="float:left;height:1.8em;" title=
        "Angezeigt wird der Zeitpunkt des Aufrufs und das Ergebnis.\nFür Extern wurde mail2ab als Skript aufgerufen. Interaktiv bedeutet  worden sein - der Button 'abholen' wird nicht gezählt!">
        Zur Info die letzten Abrufe: Extern '''+a_db.get_config('intern_last_mail2ab','(kein)')+' Interaktiv ' +a_db.get_config('intern_last_mail2ab_test','(kein)')+'''.<span style="font-size:130%">&nbsp;</span>
    </form> 
    <div style="clear:left;font-size:0"></div>
    <table>
        <tr>
            <th>Verarbeitungszeitpunkt</th>
            <th>Status</th>
            <th>Absende-Maildresse</th>
            <th>Kommentar</th>
        </tr>\n'''
    
    rowdict_list=a_db.get_rowdict_list('''
        SELECT timestamp, erfolg, adresse, aktion 
        FROM poplog
        ORDER BY timestamp DESC, rowid DESC
        LIMIT 80
    ''')
    ertxt=['fail','OK','Info','Test']
    ercol=['red','green','blue','blue']
    for row in rowdict_list:
        ts,er,ad,ak=row
        td='<td style="color:'+ercol[er%4]+'">'
        ausgabe+='<tr>'+td+ts+'</td>'+td+ertxt[er%4]+'</td>'+td+ad+'</td>'+td+ak+'</td></tr>'
    ausgabe+='</table></div>'
    return ausgabe
    
def statistiktabelle():
    '''Gibt in den Kategorien die Führenden aus:
    - Fehltage
    - fehlende Entschuldigungen
    - überfällige Entschuldigungen
    - fehlende Atteste'''
    import a_tabelle
    session=a_s.get_session()
    if not (    session.ist_ein_verwalter() or 
                (session.ist_seki_in(0) and a_tool.get_gruppenrechte('seki',18))):
        return '<h2>Unzulässiger Statistik-Abruf!</h2>'
    listenlaenge=STATISTIK_LISTEN_LAENGE
    if session.von_js!=session.bis_js:
        stattyp=' von {} bis {}'.format (a_js.get_js(session.von_js).name, a_js.get_js(a_js.get_last_kj(session.bis_js)).name )  
        zeige_klassenname=True
    else:
        stattyp=' von {} '.format (a_js.get_js(session.von_js).name)
        zeige_klassenname=False
    statschuljahr=' '+session.get_lesbares_schuljahr()+' '
    ergebnis='<div class="sh">\n'
    if session.differenziere_halbjahre:
        ergebnis+='''<form class="boxcontrol" action="a_main.py" method="POST" style="font-weight:bold;text-align:left;">
        <h2>
        <span style="float:left;">Statistik {stattyp} </span>
        <span style="float:right;"><small>
            Schuljahr: {statschuljahr}
            <input name="statsid" type="hidden" value="{statsid}"  />
            &nbsp;Halbjahre: <input name="hj" type="submit" value="alle" style="font-weight:bold;color:{h0};" />
            <input name="hj" type="submit" value="1. Hj" style="font-weight:bold;color:{h1};" />
            <input name="hj" type="submit" value="2. HJ" style="font-weight:bold;color:{h2};" />
        </small></span></h2>
        </form>'''.format( statsid=session.sid, h0='#444' if session.anzeigehalbjahr!=0 else 'blue' \
                                             , stattyp=stattyp, h1='#444' if session.anzeigehalbjahr!=1 else 'blue' \
                                 , statschuljahr=statschuljahr, h2='#444' if session.anzeigehalbjahr!=2 else 'blue' )
    else:
        ergebnis+='''<form class="boxcontrol" action="a_main.py" method="POST" style="font-weight:bold;text-align:left;">
        <h2><span style="float:left;">Statistik {stattyp}</span><span style="float:right;"><small>
            Schuljahr: {statschuljahr}
            <input name="statsid" type="hidden" value="{statsid}"  />
            &nbsp;Halbjahre: <input name="hj" type="submit" value="alle" style="font-weight:bold;color:{h0};" />
        </small></span></h2></form>'''.format( statsid=session.sid, stattyp=stattyp, \
                                 statschuljahr=statschuljahr, h0='#444' if session.anzeigehalbjahr!=0 else 'blue')
    
    ## Nach Fehltagen
    if session.ist_ein_verwalter():
        ergebnis+='<div class="s1 w35">Fehltage<br><small>Gesamtzahl (Quote,unentschuldigte, fehlende Atteste)</small><br>\n'
        ergebnis+='<ul class="chartlist" style="width: 32em;">\n'
        rowdict_list=a_db.get_rowdict_list('''
             SELECT personen.pid,name,apdatum,js,klasse,count(datum) as summe 
             FROM   personen,absenzen 
             WHERE  personen.pid=absenzen.pid AND status>=? AND js BETWEEN ? AND ?
               AND  datum BETWEEN ? AND ?
             GROUP BY name 
             ORDER BY summe DESC''',
             (LEVEL_VERMISST,session.von_js,session.bis_js,session.verwaltungszeitraum_anfang,session.verwaltungszeitraum_ende))
        statistik=[]
        for row in rowdict_list:
            pid,name,apdatum,js,klasse,count=row
            statistik.append([pid,name,apdatum,js,klasse,count])
            
        zaehler=0
        for [pid,name,apdatum,js,klasse,count] in statistik:
            if zeige_klassenname:
                if not len(klasse.strip()):
                    klasse='ohne '+ ( 'Klasse' if js<=19 else 'Kurs' )
                name+=' ('+klasse+')'
            if not session.ist_verwalter_in(js):
                continue
            zaehler+=1
            if zaehler>listenlaenge:
                break
            tiptext=''
            namensergaenzung=''
            if len(apdatum)==10 and apdatum<'9999-99-99':
                namensergaenzung+='A'
                hat_attestpflicht=True
                tiptext='title="Attestpflicht seit '+a_datum.isodatum2datum(apdatum)
            else: hat_attestpflicht=False
            hatte_gespraech=False
            rowdict_list=a_db.get_rowdict_list('''SELECT datum,klarname,kommentar FROM gespraeche WHERE pid=? AND  datum BETWEEN ? AND ?''',(pid,session.verwaltungszeitraum_anfang,session.verwaltungszeitraum_ende))
            for row in rowdict_list:
                datum,klarname,kommentar=row
                if not hatte_gespraech:
                    if not tiptext:
                        tiptext=' title="'
                    else:
                        tiptext+='\n\n'
                    namensergaenzung+='g'
                    tiptext+='Gespräch(e) am:'
                    hatte_gespraech=True
                tiptext+='\n '+a_datum.isodatum2datum(datum)+' ('+klarname+')'
            if tiptext:
                tiptext+='"'
                name+=' <b>'+namensergaenzung+'</b>'
            est=a_tabelle.get_einzelstatustabelle(pid,js,apdatum)
            ergebnis+='\t<li '+tiptext+'>'+a_tool.name_mit_href(name,pid)+'\n'
            ergebnis+='\t\t<span class="count">'+str(count)+'</span>\n'
            ergebnis+='\t\t<span class="countright">(<small>'+str(est.quote[0])+' %</small>, '+str(est.unentschuldigt[0])+', '+str(est.attestfehlt[0])+')</span>\n'
            if hat_attestpflicht:
                ergebnis+='\t\t<span class="indexa" style="width:'+str(count)+'%">('+str(count)+'%)</span>\n'
            elif hatte_gespraech:
                ergebnis+='\t\t<span class="indexg" style="width:'+str(count)+'%">('+str(count)+'%)</span>\n'
            else:
                ergebnis+='\t\t<span class="index" style="width:'+str(count)+'%">('+str(count)+'%)</span>\n'
            ergebnis+='\t</li>\n'
        ergebnis+='</ul>\n</div>\n'
    
    stichtag_von=a_datum.isodatum_plus_tage(a_datum.get_heutedatum(),-FRIST_VON_UEBERFAELLIG)
    stichtag_bis=a_datum.isodatum_plus_tage(a_datum.get_heutedatum(),-FRIST_BIS_UEBERFAELLIG) if session.ist_ein_verwalter() else a_datum.get_heutedatum()
    
    ## Nach fehlenden ...
    statistikname=[ 'Fehlende Entschuldigungen<br>',
                    'Fällige Entschuldigungen<br><small>zwischen '+str(FRIST_BIS_UEBERFAELLIG)+' und '+str(FRIST_VON_UEBERFAELLIG)+' Tage alt</small>',
                    'Fehlende Atteste<br>']
    if not session.ist_ein_verwalter():
        statistikname[1]='Fehlende Entschuldigungen der letzten '+str(FRIST_VON_UEBERFAELLIG)+' Tage<br>'
    statclass=['','go_yellow','']
    for statistikkategorie in range(3):
        if statistikkategorie==1 and not session.zeige_reales_schuljahr:
            continue
        if not session.ist_ein_verwalter() and not statistikkategorie==1:
            continue
        ergebnis+=  '<div class="s2 '+statclass[statistikkategorie]+'">'+statistikname[statistikkategorie]+ \
                    '<br>\n<ul class="statlist">\n'
        if statistikkategorie==0:
            rowdict_list=a_db.get_rowdict_list('''
             SELECT personen.pid,name,apdatum,js,count(datum) as summe 
             FROM   personen,absenzen 
             WHERE  personen.pid=absenzen.pid AND status>=? AND status<? 
                AND attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                AND js BETWEEN ? AND ?
                AND datum BETWEEN ? AND ?
             GROUP BY name 
             ORDER BY summe DESC
             LIMIT ?''',(LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG,session.von_js,session.bis_js,session.verwaltungszeitraum_anfang,session.verwaltungszeitraum_ende,listenlaenge))
        if statistikkategorie==1:
            rowdict_list=a_db.get_rowdict_list('''
             SELECT personen.pid,name,apdatum,js,count(datum) as summe 
             FROM   personen,absenzen 
             WHERE  personen.pid=absenzen.pid AND status>=? AND status<? 
                AND attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                AND js BETWEEN ? AND ?
                AND datum BETWEEN ? AND ?
             GROUP BY name 
             ORDER BY summe DESC
             LIMIT ?''',(LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG,session.von_js,session.bis_js,stichtag_von,stichtag_bis,listenlaenge))
        if statistikkategorie==2:
            rowdict_list=a_db.get_rowdict_list('''
             SELECT personen.pid,name,apdatum,js,count(datum) as summe 
             FROM   personen,absenzen 
             WHERE  personen.pid=absenzen.pid AND status BETWEEN ? AND ?
              AND   ( attestpflicht=1 OR (apdatum>"2012-00-00" AND apdatum<absenzen.datum ))
              AND js BETWEEN ? AND ?
              AND  datum BETWEEN ? AND ?
             GROUP BY name 
             ORDER BY summe DESC
             LIMIT ?''',(LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG, \
                        session.von_js,session.bis_js,session.verwaltungszeitraum_anfang,session.verwaltungszeitraum_ende,listenlaenge))    
        
        
        findeflagge=False
        pidliste=[]
        for row in rowdict_list:
            pid,name,apdatum,js,count=row
            findeflagge=True
            pidliste.append([pid,name,apdatum,js,count])
        for [pid,name,apdatum,js,count] in pidliste:
            if not session.ist_verwalter_in(js):
                continue
            popup='<b>'+name
            if len(apdatum)==10 and apdatum<'9999-99-99':
                popup+='<br><small>(Attestpflicht seit '+a_datum.isodatum2datum(apdatum)+')</small>'
            popup+='</b>'
            if statistikkategorie==0:
                rowdict_list=a_db.get_rowdict_list('''
                    SELECT datum, status, kommentar FROM absenzen, personen
                    WHERE absenzen.pid=? AND personen.pid=absenzen.pid AND status>=? AND status<? AND
                     attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                    ORDER BY datum
                    ''',(pid,LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG))
            if statistikkategorie==1:
                rowdict_list=a_db.get_rowdict_list('''
                    SELECT datum, status, kommentar FROM absenzen, personen
                    WHERE absenzen.pid=? AND personen.pid=absenzen.pid AND status>=? AND status<? AND
                     attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                     AND datum BETWEEN ? AND ?
                    ORDER BY datum
                    ''',(pid,LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG,stichtag_von,stichtag_bis))
            if statistikkategorie==2:
                rowdict_list=a_db.get_rowdict_list('''
                    SELECT  datum, status, kommentar FROM personen, absenzen
                    WHERE   absenzen.pid=? AND personen.pid=absenzen.pid AND status BETWEEN ? AND ?
                     AND    ( attestpflicht=1 OR (apdatum>"2012-00-00" AND apdatum<absenzen.datum ))
                    ORDER BY datum
                    ''',(pid,LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG))    
            for row in rowdict_list:
                datum,status,kommentar=row
                popup+='<strong>'+a_datum.isodatum2datum(datum)+' ('+STATUSSTRGLONG[status]+')</strong><br>&nbsp;&nbsp;'
                popup+='<br>&nbsp;&nbsp;'.join(kommentar.split('<br>'))+'<br>'
            ergebnis+='\t<li>'+a_tool.name_mit_href(name,pid,popup)+'\n'
            ergebnis+='\t\t<span>'+str(count)+'</span>\n'
            ergebnis+='\t</li>\n'
            
        if not findeflagge:
            ergebnis+='\t<li><span>kein Eintrag</span></li>\n'
        ergebnis+='</ul>\n'
        ergebnis+='</div>'
    
    
    ergebnis+='<div style="clear:left;"></div>\n</div>'
    return ergebnis
    
def stammdatenanzeige_schueler(schuelercodes=False,schuelerbrief=False):
    session=a_s.get_session()
    ergebnis='<div class="sh"><h2>Stammdaten Schüler</h2>\n'
    dkursjahre=[['']]*6
    for i in range(1,6):
        kursjahrname=a_js.get_kj(i).name
        if kursjahrname:
            dkursjahre[i]=['''<div class="s2">Schüler {kursjahrname} 
            <table><tr><th style="width:12em;">Schülername<br>&nbsp;&nbsp;Mail-Code</th><th style="width:12em;">Gewählte Kurse</th>
            </tr>\n'''.format(kursjahrname=kursjahrname)]
    d_kj_flag=[False]*6
    #d2=['<div class="s2">Schüler Q12 <table><tr><th style="width:12em;">Schülername<br>&nbsp;&nbsp;Mail-Code</th><th style="width:12em;">Gewählte Kurse</th></tr>\n']
    dk_head='<div class="s2">Schüler {}<table><tr><th style="width:10em;">Schülername</th><th style="width:3em;">Klasse</th></tr>\n'
    dklassen=[  [''],   [dk_head.format(a_js.get_ks(1).name)], \
                        [dk_head.format(a_js.get_ks(2).name)], \
                        [dk_head.format(a_js.get_ks(3).name)]  ]
    d_ks_flag=[False]*4
    scsv=["Name,Code\r\n"]
    serienbrief=[]
    if schuelerbrief:
        kopf,seite,fuss,seitenseparator=a_tool.lese_htmlvorlage_ein('mailcodebrief.html')
        serienbrief=[kopf]
    # alle schüler einlesen
    pidliste=a_db.get_rowdict_list('SELECT name,zugriffscode,pid,js,klasse,ordnungsmerkmal FROM personen ORDER BY js,sortiername')
    for name,code,pid,js,klasse,ordnungsmerkmal in pidliste:    
        ## debugging: a_tool.prt(name+code+' '+str(pid)+' JS:'+str(js)+' Kl:'+klasse+" - - - ")
        if js>20:
            #alle Daten für einen Oberstufen-Schüler einlesen
            item_list=a_db.get_column_list('''    SELECT kurse.kbez 
                                    FROM kurse,p2k
                                    WHERE p2k.pid=? AND
                                          p2k.kbez=kurse.kbez''',(pid,))
            seinekurse=""
            zaehler=0
            for seinkurs in item_list:
                    zaehler+=1
                    if not zaehler%5:
                        seinekurse+="<br>"
                    seinekurse+= seinkurs +", "
            extrastyle="" if zaehler else ' style="background:#FAA;"'
            code='ACD'+code
            scsv.append('"'+name+'",'+code+"\n")
            if False:
                splitname=name.split(" ",1)
                fettname='<b>'+splitname[0]+'</b> '
                if len(splitname)>0:
                    fettname+=splitname[1]
            else:
                fettname='<b>'+name+'</b>'
            dkursjahre[js-20].append('<tr'+extrastyle+'><td>'+fettname+("&nbsp;✔" if ordnungsmerkmal else "")+'<br><br>&nbsp;&nbsp;'+code+'</td><td><small>'+seinekurse+'</small></td></tr>\n')
            d_kj_flag[js-20]=True
            if schuelerbrief:
                einzelseite=seite
                einzelseite=einzelseite.replace('ABINFOSCHUELERNAME',name)
                einzelseite=einzelseite.replace('ABINFOMAILCODE',code)
                einzelseite=einzelseite.replace('ABSTUNDEMORGEN',str(a_db.get_config_int('aa-stundemorgen')))
                einzelseite=einzelseite.replace('ABSTUNDEGRENZE',str(a_db.get_config_int('aa-stundegrenze')))
                einzelseite=einzelseite.replace('ABMAILADRESSE',a_db.get_config('aa-mailadresse'))
                
                serienbrief.append(einzelseite+seitenseparator)
        else: # Daten für einen Nicht-Oberstufen-Schüler einlesen
            extrastyle="" if klasse else ' style="background:#FAA;"'
            if js>0 and session.ist_berechtigt_in[js]>2:
                ks=a_js.get_js(js).ks   # Klassenstufe 1-3 errechnen
                dklassen[ks].append('<tr'+extrastyle+'><td>'+name+("&nbsp;✔" if ordnungsmerkmal else "")+'</td><td>'+klasse+'</td></tr>\n')
                d_ks_flag[ks]=True    # merken, dass in der ks etwas eingetragen wurde
        
    if schuelercodes:
        return "".join(scsv)
    if schuelerbrief:
        return "".join(serienbrief)+fuss
    
    if session.ist_berechtigt_in[20]:
        for i in range(1,a_js.get_last_kj()-19):
            if d_kj_flag[i]:
                dkursjahre[i].append('</table></div>\n\n')
                ergebnis+=''.join(dkursjahre[i])
    minimumjs=a_db.get_config_int("minimum-js")
    for i in range(1,4):
        if d_ks_flag[i]:
            dklassen[i].append('</table></div>\n\n')
            ergebnis+=''.join(dklassen[i]) 
    ergebnis+='</div>'
    return ergebnis

def stammdatenanzeige_lehrer(lehrercodes=False,lehrerbrief=False):
    session=a_s.get_session()
    ergebnis='<div class="sh"><h2>Stammdaten Lehrer</h2>\n'
    d3=['<div class="s2">Lehrer <table><tr>']
    d3.append('''        <th style="width:10em;">Lehrername, Aliase</th>
            <th style="width:5em;">Kürzel oder ungeändertes Passwort</th>
            <th style="width:15em;">Klassen <em>KlassLeiter</em><br>{Kursleiter}<br>(Vertretungen)<br>[Sonderrechte]</th>
            <th>Zusammenfassen von Lehrer-Einträgen,<br>so dass der eine ein Alias des anderen wird.</th>''')
    d3.append('</tr>\n')
    lcsv="Name,Passwort\r\n"
    serienbrief=""
    if lehrerbrief:
        kopf,seite,fuss,seitenseparator=a_tool.lese_htmlvorlage_ein('passwortbrief.html')
        serienbrief=kopf
    
    #alle Lehrer einlesen
    userlist=a_db.get_rowdict_list('SELECT klarname,kuerzel,user_nr,rechte FROM users WHERE klarname<>"Administrator" ORDER BY sortiername')
    letzte_user_nr=0
    letzter_klarname=''
    letztes_kuerzel=''
    letzter_klaralpha='X'
    for klarname,kuerzel,user_nr,rechte in userlist:
        klaralpha=alphaonly(klarname)
        # alle Daten für einen Lehrer einlesen
        if rechte!='0000' and len(rechte)>3:
            ihre_rechte='[ '
            for i in range(4):
                if rechte[i]=='2':
                    ihre_rechte+='Stufenlehrer in '+STUFENCHAR[i]+" "
                elif rechte[i]=='4':
                    ihre_rechte+='Sekr. in '+STUFENCHAR[i]+" "
                elif rechte[i]=='9':
                    ihre_rechte+='Verw. in '+STUFENCHAR[i]+" "
            ihre_rechte+=']'
        else:
            ihre_rechte=""
        zaehler=0
        
        ihre_kurse=""
        kurszaehler=0
        
        for item in a_db.get_column_list('SELECT kbez FROM kurse WHERE klehrer_nr=? ORDER BY kbez',(user_nr,)):
            zaehler+=1
            kurszaehler+=1
            if not kurszaehler%4: ihre_kurse+='<br>'
            ihre_kurse+=item+" "

        ihre_klassen=""
        
        for item in a_db.get_column_list('SELECT kname FROM lehrerinklasse WHERE user_nr=? ORDER BY kname',(user_nr,)):
            zaehler+=1
            ihre_klassen+=item+" "
        firstkl=True
        for item in a_db.get_column_list('SELECT name FROM klassen WHERE klassleiter_nr=? ORDER BY name',(user_nr,)):
            zaehler+=1
            if firstkl: 
                ihre_klassen+='<em>KL:'
                firstkl=False
            ihre_klassen+=item+" "
        if not firstkl:
            ihre_klassen+='</em>'
        ihre_vertretungen=""
        for item in a_db.get_column_list('SELECT kbez FROM kurse WHERE vlehrer_nr=?',(user_nr,)):
            zaehler+=1
            ihre_vertretungen+=item+" "
        extrastyle="" if (ihre_klassen+ihre_kurse+ihre_vertretungen+ihre_rechte)!="" else ' style="background:#FAA;"'
        if len(kuerzel)>6:
            lcsv+='"'+klarname+'",'+kuerzel+"\n"
            if lehrerbrief:
                einzelseite=seite
                einzelseite=einzelseite.replace('ABINFOLEHRERNAME',klarname)
                einzelseite=einzelseite.replace('ABINFOPASSWORT',kuerzel)
                serienbrief+=einzelseite+seitenseparator
        aliase=a_tool.aliasliste(user_nr,',<br>')
        if aliase:
            aliase=',<br><small>'+aliase+'</small>'
        # nun die Zusammenstellung der Zeile
        d3.append('<tr'+extrastyle+'>')
        tdid=' id="Aktuell" ' if user_nr==verschmelzmaster else ''
        d3.append('<td'+tdid+'>'+klarname+aliase+'</td><td>')
        d3.append(kuerzel if (len(kuerzel)<=6 or session.kuerzel=='admin' ) else '- - -')
        if ihre_vertretungen: 
            ihre_vertretungen=' ( '+ihre_vertretungen+')'
        if ihre_klassen and (ihre_kurse or ihre_vertretungen or ihre_rechte):
            ihre_klassen+='<br>'
        if ihre_kurse:
            ihre_kurse='{ '+ihre_kurse+' }'
            if ihre_vertretungen or ihre_rechte:
                ihre_kurse+='<br>'
        if ihre_vertretungen and ihre_rechte:
            ihre_vertretungen+='<br>'
        d3.append('</td><td><small>'+ihre_klassen+ihre_kurse+ihre_vertretungen+ihre_rechte+'</small></td>')
        if session.kuerzel=='admin':
            if letzte_user_nr>0:
                hintcolor=''
                if klaralpha.startswith(letzter_klaralpha) or letzter_klaralpha.startswith(klaralpha):
                    hintcolor=' style="color:lightgreen;" '
                elif klaralpha.startswith(letzter_klaralpha[:-2]) or letzter_klaralpha.startswith(klaralpha[:-2]):
                    hintcolor=' style="color:orange" '
                thiscolor=(hintcolor if not len(kuerzel)>6          else ' style="color:yellow" ' ) if hintcolor else  ' style="color:lightgrey" '
                lastcolor=(hintcolor if not len(letztes_kuerzel)>6  else ' style="color:yellow" ' ) if hintcolor else  ' style="color:lightgrey" '
                d3.append('<td'+hintcolor+'><form action="a_main.py" method="post">'+ \
                      '<input name="vwsid" value="'''+str(session.sid)+'" type="hidden">' +\
                      '<input name="lineuser_nr" value="'+str(user_nr)+'" type="hidden">' + \
                      '<input name="vor_user_nr" value="'+str(letzte_user_nr)+'" type="hidden">' + \
                      '<input '+thiscolor+'value="'+letzter_klarname+' &nbsp; wird Alias von &nbsp; '+klarname+'" name="binmaster" type="submit"><br>' + \
                      '<input '+lastcolor+'value="'+klarname+' &nbsp; wird Alias von &nbsp; '+letzter_klarname+'" name="binalias"  type="submit">' + \
                      '</form></td>')
            else:
                d3.append('<td> </td>')
            d3.append('<td> </td>')
            #d3.append('<td><form action="a_main.py" method="post">Diesen User als Alias von:'+select+'<input value="setzen!" type="submit">' +\
            #         '<input name="vwsid" value="'''+str(session.sid)+'" type="hidden">' +\
            #        '<input name="aliasuser_nr" value="'+str(user_nr)+'" type="hidden"></form></td>')
            
        d3.append('</tr>\n')
        letzte_user_nr=user_nr
        letzter_klarname=klarname
        letztes_kuerzel=kuerzel
        letzter_klaralpha=klaralpha
    if lehrercodes:
        return lcsv
    if lehrerbrief:
        return serienbrief+fuss
    
    d3.append('</table></div>\n\n')
    
    ergebnis+='\n'.join(d3) if session.ist_berechtigt_in[0]==9 else "Keine Berechtigung zur Lehrerstatistik" # Lehrerstatistik
    
    ergebnis+='</div>'
    return ergebnis

        

def erledige_alias_verwaltung():
    dieser=a_tool.getcgiinteger("lineuser_nr")
    jener= a_tool.getcgiinteger("vor_user_nr")
    binmaster=a_tool.getcgiparameter("binmaster")
    binalias=a_tool.getcgiparameter("binalias")
    if dieser and jener:
        if binmaster and not binalias:
            return verschmelze(dieser,jener)
        elif not binmaster and binalias:
            return verschmelze(jener,dieser)

    master=a_tool.getcgiparameter("masteruser").split()[0]
    alias= a_tool.getcgiparameter("aliasuser").split()[0]
    if a_tool.getcgiparameter("zuweisen"):
        if master.isdigit() and alias.isdigit():
            m=int(master)
            a=int(alias)
            if not (m>0 and a>0):   return '-Bitte sowohl Master als auch Alias auswählen'
            if m==a:                return '-Master und Alias müssen sich unterscheiden'
            return verschmelze(m,a)
    if a_tool.getcgiparameter("loeschen"):
        if master.isdigit():
            m=int(master)
            a_db.execute('DELETE FROM useralias WHERE user_nr=?',(m,))
            return '+Alias wurde gelöscht. Ein gleichnamiger User wird wieder angelegt, sobald die entsprechende Datei wieder eingelesen wird.'
    
    return "-Zu wenig Daten für eine Aliasänderung "+str((dieser,jener,master,alias))

def verschmelze(master_nr,alias_nr):
    global verschmelzmaster
    # alle Vorkommen von alias_nr müssen ersetzt werden:
    a_db.execute('UPDATE kurse            SET klehrer_nr= :mnr        WHERE klehrer_nr    = :anr',{"mnr":master_nr,"anr":alias_nr,})
    a_db.execute('UPDATE kurse            SET vlehrer_nr= :mnr        WHERE vlehrer_nr    = :anr',{"mnr":master_nr,"anr":alias_nr,})
    a_db.execute('UPDATE klassen          SET klassleiter_nr= :mnr    WHERE klassleiter_nr= :anr',{"mnr":master_nr,"anr":alias_nr,})
    a_db.execute('UPDATE lehrerinklasse   SET user_nr= :mnr           WHERE user_nr       = :anr',{"mnr":master_nr,"anr":alias_nr,})
    a_db.execute('UPDATE useralias        SET user_nr= :mnr           WHERE user_nr       = :anr',{"mnr":master_nr,"anr":alias_nr,})
    rowdict=a_db.get_one_rowdict('SELECT kuerzel,hash FROM users WHERE user_nr=?',(master_nr,))
    if not rowdict: return '-Master nicht gefunden'
    mkuerzel,mhash=rowdict
    rowdict=a_db.get_one_rowdict('SELECT klarname,kuerzel,hash FROM users WHERE user_nr=?',(alias_nr,))
    if not rowdict: return '-zukünftiger Alias nicht gefunden'
    aklarname,akuerzel,ahash=rowdict
    a_db.execute('DELETE FROM users  WHERE user_nr       = ?',(alias_nr,))
    a_db.commit()
    # Ist der Master schon benutzt worden?
    if len(mkuerzel)>6 and len(akuerzel)<6:
        a_db.execute('UPDATE users SET kuerzel=?,hash=? WHERE user_nr = ?',(akuerzel,ahash,master_nr))
    a_db.execute('INSERT INTO useralias (aliasname,user_nr) VALUES (?,?)',(aklarname,master_nr))
    a_db.commit()
    verschmelzmaster=master_nr
    return "+"+a_tool.get_userklarname(master_nr)+' erhält den Alias '+aklarname+'. Springe <a href="#Aktuell">dorthin</a>!'  

def alphaonly(name):
    name=name.lower()
    name=name.replace('ä','ae')
    name=name.replace('ö','oe')
    name=name.replace('ü','ue')
    name=name.replace('ß','ss')
    only=[ char for char in name if char.isalpha() ]
    return ''.join(only)

def kurstage_dialog():
    session=a_s.get_session()
    ausschluss=[]
    #if session.stufe==11: # also explizit kein 12
    #    ausschluss=a_db.get_config('kurspraefix-q12')
    #elif session.stufe==12:
    #    ausschluss=a_db.get_config('kurspraefix-q11')
    if session.stufe>20:
        a_js.hole_kj_kriterien()
        for i in range(21,26):
            if i != session.stufe and a_js.get_kj(i).praefix:
                ausschluss.append(a_js.get_kj(i).praefix)
    alen=len(ausschluss)
    kliste=[]
    zaehler=0
    rowdict_list=a_db.get_rowdict_list('''
        SELECT  kbez,wochentage
        FROM    kurse
        ORDER BY kbez''')
    zeilen=['<div class="s1"><table><tr><th>Kurs</th><th>Wochentage, an denen der Kurs unterrichtet wird</th></tr>\n']
    for kbez,wochentage in rowdict_list:
        ueberspringen=False
        if alen:
            for praefix in ausschluss:
                if kbez.startswith(praefix):
                    ueberspringen=True
        if not ueberspringen:
            if zaehler % 30==0 and zaehler>0:
                zeilen.append('</table></div><div class="s2"><table><tr><th>Kurs</th><th>Wochentage, an denen der Kurs unterrichtet wird</th></tr>\n')
            zaehler+=1
            wotasel='<form action="a_main.py">'
            for i in range(5): # 0=Montag
                tag=wotage[i]  # 0->'Mo'
                wotasel+='<input type="checkbox" name="wotasel" value="'+tag+'"'
                if wochentage & (1 << i):
                    wotasel+=' checked '
                else:
                    tag='<span style="color:grey;">'+tag+'</span>'
                wotasel+='>'+tag+'</input>&nbsp; &nbsp; &nbsp;'
            wotasel+='<input type="hidden" name="kbez" value="'+kbez+'" />'
            wotasel+='<input type="hidden" name="wotaselsid" value="'+str(session.sid)+'" />'
            wotasel+='<input type="Submit"  value="Ändern" />'
            
            wotasel+='</form>'
            zeilen.append('<tr><td>&nbsp;'+kbez+'&nbsp;</td><td>'+wotasel+'</td></tr>\n')
    zeilen.append('</table></div>')
    ergebnis='\n'.join(zeilen)
    return ergebnis
    
def kurstage_verarbeitung():
    session=a_s.get_session()
    if not (session.zeige_konfiguriertes_schuljahr):
        return "-Nur mit für dieses Schuljahr eingelesenen Listen können Kurstage sinnvoll eingetragen werden"
    wotaselsid=a_tool.getcgiparameter('wotaselsid')
    if wotaselsid!=str(session.sid): return ''
    kbez=a_tool.getcgiparameter('kbez')
    if not kbez: return '-Kein Wert erkannt'
    wotasel=a_tool.getcgilist('wotasel')
    wochentage=0
    for i in range(6):
        if wotage[i] in wotasel:
            wochentage+= (1 << i )
    a_db.execute('''
        UPDATE kurse SET wochentage=? WHERE kbez=?''',(wochentage,kbez))
    return '+Kurstage für '+kbez+' wurden geändert auf '+" ".join(wotasel)

zeige_monatsstatistik=a_db.get_config_int('flag_monatsstatistik')
